﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Exemplo_DFW
{
    public partial class formPrincipal : Form
    {
        int iRet = 0;
        string strMsg= string.Empty;

        public formPrincipal()
        {
            InitializeComponent();
        }

        private void btnFechar_Click(object sender, EventArgs e)
        {
            this.DestroyHandle(); //Fechar
        }

        private void btnDUAL_Click(object sender, EventArgs e)
        {   
            formDUAL telaDUAL = new formDUAL();
            telaDUAL.Show();
        }



        private void regAlterarValorToolStripMenuItem_Click(object sender, EventArgs e)
        {
            string strChave = string.Empty;
            string strValor = string.Empty;
            iRet = 0;
            strMsg = string.Empty;

            strChave = tbxParametro1.Text;
            if (strChave != "")
            {
                strValor = tbxParametro2.Text;
                if (strValor != "")
                {
                    iRet = Declaracoes.regAlterarValor_Daruma(strChave, strValor);
                    strMsg = Exemplo_DFW.Declaracoes.TrataRetorno_DUAL(iRet);
                    MessageBox.Show("Retorno do método: " + strMsg, "TrataRetorno_DUAL", MessageBoxButtons.OK, MessageBoxIcon.Information);
                }
                else
                {
                    MessageBox.Show("Obrigatorio Informar os parametros.", "Exemplo_DFW", MessageBoxButtons.OK, MessageBoxIcon.Error);

                }
            }
            else
            {
                MessageBox.Show("Obrigatorio Informar os parametros.", "Exemplo_DFW", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }

        }

        private void regRetornaValorChaveDarumaFrameworkToolStripMenuItem_Click(object sender, EventArgs e)
        {
            string strProduto = string.Empty;
            string strChave = string.Empty;
            StringBuilder strValor = new StringBuilder();
            strValor.Length = 400;
            iRet = 0;
            strMsg = string.Empty;

            strProduto = tbxParametro0.Text;
                
            if (strProduto != "")
            {
                strChave = tbxParametro1.Text;
                
                if (strChave != "")
                {
                    
                    iRet = Declaracoes.regRetornaValorChave_DarumaFramework(strProduto, strChave, strValor);
                    strMsg = Exemplo_DFW.Declaracoes.TrataRetorno_DUAL(iRet);
                    tbxParametro2.Text = strValor.ToString();
                    MessageBox.Show("Retorno do método: " + strMsg, "TrataRetorno_DUAL", MessageBoxButtons.OK, MessageBoxIcon.Information);
                }
                else
                {
                    MessageBox.Show("Obrigatorio Informar os parametros: Produto e Chave a ser lida.", "Exemplo_DFW", MessageBoxButtons.OK, MessageBoxIcon.Error);

                }
            }
            else
            {
                MessageBox.Show("Obrigatorio Informar os parametros: Produto e Chave a ser lida.", "Exemplo_DFW", MessageBoxButtons.OK, MessageBoxIcon.Error);

            }
        }


        private void btnExecutar_Click(object sender, EventArgs e)
        {
            if (cbxMetodo.SelectedIndex.ToString() == "0") //eDefinirProduto
            {
                iRet = 0;
                strMsg = string.Empty;
                iRet = Exemplo_DFW.Declaracoes.eDefinirProduto_Daruma(tbxParametro0.Text);
                strMsg = Exemplo_DFW.Declaracoes.TrataRetorno_DUAL(iRet);
                MessageBox.Show("Retorno do método: " + strMsg, "TrataRetorno_DUAL", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
            else if (cbxMetodo.SelectedIndex.ToString() == "1") //eVersoesBibliotecas_Daruma
            {
                iRet = 0;
                strMsg = string.Empty;
                StringBuilder strValor = new StringBuilder();
                iRet = Exemplo_DFW.Declaracoes.eVersoesBibliotecas_Daruma(strValor);
                tbxParametro0.Enabled = true;
                tbxParametro0.Text = strValor.ToString();
                strMsg = Exemplo_DFW.Declaracoes.TrataRetorno_DUAL(iRet);
                MessageBox.Show("Retorno do método: " + strMsg, "TrataRetorno_DUAL", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
            else if (cbxMetodo.SelectedIndex.ToString() == "2") //regAlterarValor_Daruma
            {
                string strChave = string.Empty;
                string strValor = string.Empty;
                iRet = 0;
                strMsg = string.Empty;

                strChave = tbxParametro1.Text;
                if (strChave != "")
                {
                    strValor = tbxParametro2.Text;
                    if (strValor != "")
                    {
                        iRet = Declaracoes.regAlterarValor_Daruma(strChave, strValor);
                        strMsg = Exemplo_DFW.Declaracoes.TrataRetorno_DUAL(iRet);
                        MessageBox.Show("Retorno do método: " + strMsg, "TrataRetorno_DUAL", MessageBoxButtons.OK, MessageBoxIcon.Information);
                    }
                    else
                    {
                        MessageBox.Show("Obrigatorio Informar os parametros.", "Exemplo_DFW", MessageBoxButtons.OK, MessageBoxIcon.Error);

                    }
                }
                else
                {
                    MessageBox.Show("Obrigatorio Informar os parametros.", "Exemplo_DFW", MessageBoxButtons.OK, MessageBoxIcon.Error);
                }
            }
            else if (cbxMetodo.SelectedIndex.ToString() == "3") //regRetornaValorChave_DarumaFramework_Daruma
            {
                string strProduto = string.Empty;
                string strChave = string.Empty;
                StringBuilder strValor = new StringBuilder();
                strValor.Length = 400;
                iRet = 0;
                strMsg = string.Empty;

                strProduto = tbxParametro0.Text;

                if (strProduto != "")
                {
                    strChave = tbxParametro1.Text;

                    if (strChave != "")
                    {

                        iRet = Declaracoes.regRetornaValorChave_DarumaFramework(strProduto, strChave, strValor);
                        tbxParametro2.Text = strValor.ToString();
                        strMsg = Exemplo_DFW.Declaracoes.TrataRetorno_DUAL(iRet);
                        MessageBox.Show("Retorno do método: " + strMsg, "TrataRetorno_DUAL", MessageBoxButtons.OK, MessageBoxIcon.Information);
                    }
                    else
                    {
                        MessageBox.Show("Obrigatorio Informar os parametros: Produto e Chave a ser lida.", "Exemplo_DFW", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    }
                }
                else
                {
                    MessageBox.Show("Obrigatorio Informar os parametros: Produto e Chave a ser lida.", "Exemplo_DFW", MessageBoxButtons.OK, MessageBoxIcon.Error);
                }
            }
        }

        private void cbxMetodo_SelectedIndexChanged(object sender, EventArgs e)
        {
            tbxParametro0.Text = "";
            tbxParametro1.Text = "";
            tbxParametro2.Text = "";
            if (cbxMetodo.SelectedIndex == 0) //eDefinirProduto
            {
                lblParametro0.Text = "Produto:";
                lblParametro1.Text = "-";
                lblParametro2.Text = "-";
                tbxParametro0.Enabled = true;
                tbxParametro1.Enabled = false;
                tbxParametro2.Enabled = false;
                
            }
            else if (cbxMetodo.SelectedIndex == 1) //eVersoesBibliotecas_Daruma
            {
                lblParametro0.Text = "Versões Retornadas:";
                lblParametro1.Text = "-";
                lblParametro2.Text = "-";
                tbxParametro0.Enabled = false;
                tbxParametro1.Enabled = false;
                tbxParametro2.Enabled = false;
            }
            else if (cbxMetodo.SelectedIndex == 2) //regAlterarValor_Daruma
            {
                lblParametro0.Text = "-";
                lblParametro1.Text = "Caminho da Chave: (exemplo: DUAL\\Auditoria)";
                lblParametro2.Text = "Valor da Chave retornado:";
                tbxParametro0.Enabled = false;
                tbxParametro1.Enabled = true;
                tbxParametro2.Enabled = true;
            }
            else if (cbxMetodo.SelectedIndex == 3) //regRetornaValorChave_DarumaFramework_Daruma
            {
                lblParametro0.Text = "Produto:";
                lblParametro1.Text = "Chave:";
                lblParametro2.Text = "Valor da Chave retornado:";
                tbxParametro0.Enabled = true;
                tbxParametro1.Enabled = true;
                tbxParametro2.Enabled = true;
            }
        }

        private void btnLimpar_Click(object sender, EventArgs e)
        {
            tbxParametro0.Text = "";
            tbxParametro1.Text = "";
            tbxParametro2.Text = "";

        }

        private void btnSAT_Click(object sender, EventArgs e)
        {
            formSAT telaSAT = new formSAT();
            telaSAT.Show();
        }

        private void gbxDLL_Click(object sender, EventArgs e)
        {
            StringBuilder strVeroesDLLs = new StringBuilder();
            strVeroesDLLs.Length = 40;
            Declaracoes.eVersoesBibliotecas_Daruma(strVeroesDLLs);
            string strDllVersoes = strVeroesDLLs.ToString();
            string[] strSeparado = strDllVersoes.Split(';');
            lblDFW.Text = strSeparado[0];
            lblGNE.Text = strSeparado[1];
            lblWS.Text = strSeparado[2];
        }

        private void btnNFCe_Click(object sender, EventArgs e)
        {
            formNFCE telaNFCE = new formNFCE();
            telaNFCE.Show();

        }

        private void linkLabel1_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            System.Diagnostics.Process process = new System.Diagnostics.Process();
            process.StartInfo.FileName = "https://itfast.com.br/automacao";
            process.Start();
        }

        private void linkLabel2_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            System.Diagnostics.Process process = new System.Diagnostics.Process();
            process.StartInfo.FileName = "https://wa.me/5512996873445";
            process.Start();
        }

        private void linkLabel3_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            System.Diagnostics.Process process = new System.Diagnostics.Process();
            process.StartInfo.FileName = "https://itfast.com.br/site/help";
            process.Start();
        }

        private void label8_Click(object sender, EventArgs e)
        {

        }

        private void label1_Click(object sender, EventArgs e)
        {

        }
    }

}
