﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Exemplo_DFW
{
    public partial class formDUAL : Form
    {
        String strMsg = string.Empty;
        int iRet = 0;
        public formDUAL()
        {
            InitializeComponent();
        }

        private void btnFechar_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void btnLer_Click(object sender, EventArgs e)
        {
            StringBuilder strModelo = new StringBuilder();
            StringBuilder strVersaoFw = new StringBuilder();
            strVersaoFw.Length = 8;
            lblModelo.Text = "modelo";
            lblVersao.Text = "versao";

            if (ckbModelo.Checked.Equals(true))
            {
                iRet = Declaracoes.rModelo_DUAL_DarumaFramework(strModelo);
                strMsg = Declaracoes.TrataRetorno_DUAL(iRet);
                MessageBox.Show("Retorno do método rModelo_DUAL: " + strMsg, "TrataRetorno_DUAL", MessageBoxButtons.OK, MessageBoxIcon.Information);
                if (iRet == 1)
                {
                    lblModelo.Text = strModelo.ToString();
                }
            }
            if (ckbVersao.Checked.Equals(true))
            {
                iRet = Declaracoes.rVersaoFW_DUAL_DarumaFramework(strVersaoFw);
                strMsg = Declaracoes.TrataRetorno_DUAL(iRet);
                MessageBox.Show("Retorno do método rVersaoFW_DUAL: " + strMsg, "TrataRetorno_DUAL", MessageBoxButtons.OK, MessageBoxIcon.Information);
                if (iRet == 1)
                {
                    lblVersao.Text = strVersaoFw.ToString();
                }
            }


        }

        private void cbxMetodosDUAL_SelectedIndexChanged(object sender, EventArgs e)
        {

            if (cbxMetodosDUAL.SelectedIndex < 7)
            {
                tbxTexto.Enabled = false;
                lblParam0.Text = "-";
                tbxParam0.Enabled = false;
                lblParam1.Text = "-";
                tbxParam1.Enabled = false;
                lblParam2.Text = "-";
                tbxParam2.Enabled = false;
            }
            else if (cbxMetodosDUAL.SelectedIndex == 7) //iImprimirTexto_DUAL
            {
                tbxTexto.Enabled = true;
                lblParam0.Text = "-";
                tbxParam0.Enabled = false;
                lblParam1.Text = "-";
                tbxParam1.Enabled = false;
                lblParam2.Text = "-";
                tbxParam2.Enabled = false;
            }
            else if (cbxMetodosDUAL.SelectedIndex == 8) //iImprimirArquivo_DUAL
            {
                tbxTexto.Enabled = false;
                lblParam0.Text = "Path e Nome Completo do Arquivo: ";
                tbxParam0.Enabled = true;
                lblParam1.Text = "-";
                tbxParam1.Enabled = false;
                lblParam2.Text = "-";
                tbxParam2.Enabled = false;
            }
            else if (cbxMetodosDUAL.SelectedIndex == 9) //iImprimirBMP_DUAL
            {
                tbxTexto.Enabled = false;
                lblParam0.Text = "Path e Nome Completo do arquivo BMP para impressão: ";
                tbxParam0.Enabled = true;
                lblParam1.Text = "-";
                tbxParam1.Enabled = false;
                lblParam2.Text = "-";
                tbxParam2.Enabled = false;
            }
            else if (cbxMetodosDUAL.SelectedIndex == 10) //iEnviarBMP_DUAL
            {
                tbxTexto.Enabled = false;
                lblParam0.Text = "Path e Nome Completo do arquivo BMP a ser carregado: ";
                tbxParam0.Enabled = true;
                lblParam1.Text = "-";
                tbxParam1.Enabled = false;
                lblParam2.Text = "-";
                tbxParam2.Enabled = false;
            }
            else if (cbxMetodosDUAL.SelectedIndex == 11) //iConfigurarGuilhotina_DUAL_
            {
                tbxTexto.Enabled = false;
                lblParam0.Text = "Habilitar?(Indique o número [1] Habilita / [0] Desabilita): ";
                tbxParam0.Enabled = true;
                lblParam1.Text = "Número de linhas (salto de linhas antes do corte)";
                tbxParam1.Enabled = true;
                lblParam2.Text = "-";
                tbxParam2.Enabled = false;
            }
            else if (cbxMetodosDUAL.SelectedIndex == 12) //eGerarQrCodeArquivo_DUAL
            {
                tbxTexto.Enabled = false;
                lblParam0.Text = "Path e Nome Completo do arquivo (Exemplo: C:\\teste\\arqQrCode.bmp): ";
                tbxParam0.Enabled = true;
                lblParam1.Text = "Conteúdo do QrCode:";
                tbxParam1.Enabled = true;
                lblParam2.Text = "-";
                tbxParam2.Enabled = false;
            }
            else if (cbxMetodosDUAL.SelectedIndex == 13) //rConsultaStatusImpressora_DUAL
            {
                tbxTexto.Enabled = false;
                lblParam0.Text = "Indice do status (pode variar de 1 até 8): ";
                tbxParam0.Enabled = true;
                lblParam1.Text = "Tipo de retorno ([0] Número, [1] Texto):";
                tbxParam1.Enabled = true;
                lblParam2.Text = "Retorno: ";
                tbxParam2.Enabled = false;
            }
        }

        private void btnExecutar_Click(object sender, EventArgs e)
        {
            iRet = 0;
            if (cbxMetodosDUAL.SelectedIndex == 0)//eBuscarPortaVelocidade_DUAL
            {
                iRet = Declaracoes.eBuscarPortaVelocidade_DUAL_DarumaFramework();
                strMsg = Declaracoes.TrataRetorno_DUAL(iRet);
                MessageBox.Show("Retorno do método: " + strMsg, "TrataRetorno_DUAL", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
            if (cbxMetodosDUAL.SelectedIndex == 1)//rModelo_DUAL
            {
                StringBuilder strModelo = new StringBuilder();
                iRet = Declaracoes.rModelo_DUAL_DarumaFramework(strModelo);
                strMsg = Declaracoes.TrataRetorno_DUAL(iRet);
                MessageBox.Show("Retorno do método: " + strMsg + "  Modelo retornado: " + strModelo.ToString(), "TrataRetorno_DUAL", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
            if (cbxMetodosDUAL.SelectedIndex == 2)//rVersaoFW_DUAL
            {
                StringBuilder strVersaoFw = new StringBuilder();
                strVersaoFw.Length = 8;
                iRet = Declaracoes.rVersaoFW_DUAL_DarumaFramework(strVersaoFw);
                strMsg = Declaracoes.TrataRetorno_DUAL(iRet);
                MessageBox.Show("Retorno do método: " + strMsg + "  Versão de Firmware: " + strVersaoFw.ToString(), "TrataRetorno_DUAL", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
            if (cbxMetodosDUAL.SelectedIndex == 3)//rStatusGaveta_DUAL
            {
                int iStatus = 0;
                iRet = Declaracoes.rStatusGaveta_DUAL_DarumaFramework(ref iStatus);
                if ((iRet == 1) && (iStatus == 1))
                    strMsg = "[1] Gaveta Aberta.";
                else if ((iRet == 1) && (iStatus == 0))
                    strMsg = "[0] Gaveta Fechada";
                else
                    strMsg = "[" + iRet.ToString() + "] Retorno inesperado para o método (" + iStatus.ToString() + ") retornado em iStatus";
                MessageBox.Show("Retorno do método: " + strMsg, "TrataRetorno_DUAL", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
            if (cbxMetodosDUAL.SelectedIndex == 4)//rStatusGuilhotina_DUAL
            {
                iRet = Declaracoes.rStatusGuilhotina_DUAL_DarumaFramework();
                if (iRet == 1)
                    strMsg = "[1] Guilhotina Habilitada.";
                else if (iRet == 0)
                    strMsg = "[0] Guilhotina Desabilitada";
                else
                    strMsg = "[" + iRet.ToString() + "] Retorno inesperado para o método";
                MessageBox.Show("Retorno do método: " + strMsg, "TrataRetorno_DUAL", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
            if (cbxMetodosDUAL.SelectedIndex == 5)//rStatusImpressora_DUAL
            {
                iRet = Declaracoes.rStatusImpressora_DUAL_DarumaFramework();
                strMsg = Declaracoes.TrataRetorno_DUAL(iRet);
                MessageBox.Show("Retorno do método: " + strMsg, "TrataRetorno_DUAL", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
            if (cbxMetodosDUAL.SelectedIndex == 6)//iAcionarGaveta_DUAL
            {
                iRet = Declaracoes.iAcionarGaveta_DUAL_DarumaFramework();
                strMsg = Declaracoes.TrataRetorno_DUAL(iRet);
                MessageBox.Show("Retorno do método: " + strMsg, "TrataRetorno_DUAL", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
            if (cbxMetodosDUAL.SelectedIndex == 7)//iImprimirTexto_DUAL
            {
                iRet = Declaracoes.iImprimirTexto_DUAL_DarumaFramework(tbxTexto.Text, 0);
                strMsg = Declaracoes.TrataRetorno_DUAL(iRet);
                MessageBox.Show("Retorno do método: " + strMsg, "TrataRetorno_DUAL", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
            if (cbxMetodosDUAL.SelectedIndex == 8)//iImprimirArquivo_DUAL
            {
                if (tbxParam0.Text != "")
                {
                    iRet = Declaracoes.iImprimirArquivo_DUAL_DarumaFramework(tbxParam0.Text);
                    strMsg = Declaracoes.TrataRetorno_DUAL(iRet);
                    MessageBox.Show("Retorno do método: " + strMsg, "TrataRetorno_DUAL", MessageBoxButtons.OK, MessageBoxIcon.Information);
                }
                else
                {
                    MessageBox.Show("Informe o caminho do arquivo para impressão.", "Exemplo_DFW - DUAL", MessageBoxButtons.OK, MessageBoxIcon.Information);
                }
            }
            if (cbxMetodosDUAL.SelectedIndex == 9) //iImprimirBMP_DUAL
            {
                if (tbxParam0.Text != "")
                {
                    iRet = Declaracoes.iImprimirBMP_DUAL_DarumaFramework(tbxParam0.Text);
                    strMsg = Declaracoes.TrataRetorno_DUAL(iRet);
                    MessageBox.Show("Retorno do método: " + strMsg, "TrataRetorno_DUAL", MessageBoxButtons.OK, MessageBoxIcon.Information);
                }
                else
                {
                    MessageBox.Show("Informe o caminho do BMP para impressão.", "Exemplo_DFW - DUAL", MessageBoxButtons.OK, MessageBoxIcon.Information);
                }
            }
            if (cbxMetodosDUAL.SelectedIndex == 10) //iEnviarBMP_DUAL
            {
                if (tbxParam0.Text != "")
                {
                    iRet = Declaracoes.iEnviarBMP_DUAL_DarumaFramework(tbxParam0.Text);
                    strMsg = Declaracoes.TrataRetorno_DUAL(iRet);
                    MessageBox.Show("Retorno do método: " + strMsg, "TrataRetorno_DUAL", MessageBoxButtons.OK, MessageBoxIcon.Information);
                }
                else
                {
                    MessageBox.Show("Informe o caminho do arquivo para envio pra impressora.", "Exemplo_DFW - DUAL", MessageBoxButtons.OK, MessageBoxIcon.Information);
                }
            }
            if (cbxMetodosDUAL.SelectedIndex == 11) //iConfigurarGuilhotina_DUAL_
            {
                int iHabilita = 0;
                int iNumLin = 0;
                if ((tbxParam0.Text != "") && (tbxParam1.Text != ""))
                {
                    iHabilita = int.Parse(tbxParam0.Text);
                    iNumLin = int.Parse(tbxParam1.Text);
                    iRet = Declaracoes.iConfigurarGuilhotina_DUAL_DarumaFramework(iHabilita, iNumLin);
                    strMsg = Declaracoes.TrataRetorno_DUAL(iRet);
                    MessageBox.Show("Retorno do método: " + strMsg, "TrataRetorno_DUAL", MessageBoxButtons.OK, MessageBoxIcon.Information);
                }
                else
                {
                    MessageBox.Show("Informe os dois parâmetros", "Exemplo_DFW - DUAL", MessageBoxButtons.OK, MessageBoxIcon.Information);
                }
            }
            if (cbxMetodosDUAL.SelectedIndex == 12) //eGerarQrCodeArquivo_DUAL
            {
                string strArquivo = "";
                string strConteudo = "";

                if ((tbxParam0.Text != "") && (tbxParam1.Text != ""))
                {
                    strArquivo = tbxParam0.Text;
                    strConteudo = tbxParam1.Text;
                    iRet = Declaracoes.eGerarQrCodeArquivo_DUAL_DarumaFramework(strArquivo, strConteudo);
                    strMsg = Declaracoes.TrataRetorno_DUAL(iRet);
                    MessageBox.Show("Retorno do método: " + strMsg, "TrataRetorno_DUAL", MessageBoxButtons.OK, MessageBoxIcon.Information);
                }
                else
                {
                    MessageBox.Show("Informe os dois parâmetros", "Exemplo_DFW - DUAL", MessageBoxButtons.OK, MessageBoxIcon.Information);
                }

            }
            if (cbxMetodosDUAL.SelectedIndex == 13) //rConsultaStatusImpressora_DUAL
            {
                string strIndice = "";
                string strTpRet = "";
                StringBuilder strRetorno = new StringBuilder();
                strRetorno.Length = 32;

                if ((tbxParam0.Text != "") && (tbxParam1.Text != ""))
                {
                    strIndice = tbxParam0.Text;
                    strTpRet = tbxParam1.Text;
                    iRet = Declaracoes.rConsultaStatusImpressora_DUAL_DarumaFramework(strIndice, strTpRet, strRetorno);
                    strMsg = Declaracoes.TrataRetorno_DUAL(iRet);
                    tbxParam2.Enabled = true;
                    tbxParam2.Text = strRetorno.ToString();
                    MessageBox.Show("Retorno do método: " + strMsg, "TrataRetorno_DUAL", MessageBoxButtons.OK, MessageBoxIcon.Information);
                    tbxParam2.Enabled = false;
                }
                else
                {
                    MessageBox.Show("Informe os dois parâmetros", "Exemplo_DFW - DUAL", MessageBoxButtons.OK, MessageBoxIcon.Information);
                }
            }

        }

        private void btnLimpar_Click(object sender, EventArgs e)
        {
            tbxTexto.Clear();
        }

        private void btnLimparParam_Click(object sender, EventArgs e)
        {
            tbxParam0.Text = "";
            tbxParam1.Text = "";
            tbxParam2.Text = "";
        }
    }
}