using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;
using System.Windows.Forms;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Threading;

namespace Exemplo_DFW
{
    public class Declaracoes
    {
        public static int iStatus;
        public static int iValor;
        public static int iCanc;
        public static int iRetorno;
        public static int iRetornoModem;
        public static string sBuffer = string.Empty;
        public static string Str_LabelInputBox, Str_TextoInputBox, Str_Retorno_InputBox;
        public static string Str_Aleatorio;
        public static int iAleatorio;
 
        public static string TrataRetorno_DUAL(int iRetorno)
        {
            string strRet = string.Empty;

            switch (iRetorno)
            {
                case 1: strRet = "[1] - Mtodo executado com sucesso/ Impresso OK"; break;
                case 0: strRet = "[0] - Impressora Desligada"; break;
                case -1: strRet = "[-1] - Arquivo no Formato Invlido"; break;
                case -2: strRet = "[-2] - Arquivo Corrompido/ Erro de Estrutura"; break;
                case -3: strRet = "[-3] - BMP No  Monocramtico"; break;
                case -4: strRet = "[-4] - Imagem No Possui Compctao"; break;
                case -8: strRet = "[-8] - No Foi Possvel Lococalizar o Arquivo"; break;
                case -9: strRet = "[-9] - No Fo Possvel Criar Arquivo Temporrio"; break;
                case -10: strRet = "[-10] - Impressora No Modo Grfico"; break;
                case -27: strRet = "[-27] - Erro Generico!"; break;
                case -50: strRet = "[-50] - Impressora OFF-LINE!"; break;
                case -51: strRet = "[-51] - Impressora Sem Papel"; break;
                case -52: strRet = "[-52] - Impressora inicializando"; break;
                case -54: strRet = "[-54] - Tampa da impressora aberta"; break;
                case -99: strRet = "[-99] - Metodo no executado, parmetro invlido."; break;
                default: strRet = "[" + iRetorno.ToString() + "] - Cdigo de retorno no esperado ou no mapeado no exemplo."; break;
            }
            return strRet;
        }
        public static string TrataRetorno_NFCe(int iRetorno)
        {
            string strRet = string.Empty;

            switch (iRetorno)
            {
                case 7: strRet = "[7] - Encerramento gerou apenas o descarte da nota, sem gerar uma nova nota/ numerao"; break;
                case 5: strRet = "[5] - Encerramento foi feito em Contingncia Offline, com salto de numerao e referncia para descarte da nota original."; break;
                case 4: strRet = "[4] - Encerramento foi feito em Contingncia OnLine - por TimeOut Sefaz."; break;
                case 3: strRet = "[3] - Encerramento foi feito em Contingncia OnLine"; break;
                case 2: strRet = "[2] - Encerramento foi feito em Contingncia Offline, sem mudar numerao da nota"; break;
                case 1: strRet = "[1] - Comando executado com sucesso!"; break;
                case 0: strRet = "[0] - No foi possvel comunicar com a impressora no fiscal!"; break;
                case -1: strRet = "[-1] - Erro encontrado na execuo do mtodo!"; break;
                case -2: strRet = "[-2] - Chave Invlida (Erro retornado pelo webservice)!"; break;
                case -3: strRet = "[-3] - Falha no schema XML (Erro retornado pelo webservice)!"; break;
                case -4: strRet = "[-4] - XML fora do padro (Erro retornado pelo webservice)!"; break;
                case -5: strRet = "[-5] - Erro genrico (Erro retornado pelo webservice)!"; break;
                case -6: strRet = "[-6] - Nota j cadastrada na base de dados!"; break;
                case -8: strRet = "[-8] - Usurio no Autorizado!"; break;
                case -9: strRet = "[-9] - Usurio no Licenciado!"; break;
                case -10: strRet = "[-10] - Documento e Ambiente no identificados!"; break;
                case -11: strRet = "[-11] - ndice inexistente passado como parmetro!";  break;
                case -12: strRet = "[-12] - Pagamento informado no existe no cupom!"; break;
                case -13: strRet = "[-13] - Tipo de Documento no identificado!"; break;
                case -14: strRet = "[-14] -  Erro retornado pelo WebService!"; break;
                case -16: strRet = "[-16] -  TimeOut na Comunicao com o WebService ou Erro Desconhecido retornado"; break;
                case -17: strRet = "[-17] -  Erro, usurio com Certificado Vencido"; break;
                case -19: strRet = "[-19] -  Nenhum documento localizado na base de dados"; break;
                case -20: strRet = "[-20] -  Item j possui desconto/ acrescimo "; break;
                case -21: strRet = "[-21] - No existe acrscimo ou desconto a ser cancelado!"; break;
                case -22: strRet = "[-22] - Erro na gerao de arquivo PDF"; break;
                case -23: strRet = "[-23] - Erro, o arquivo PDF est aberto por outra aplicao"; break;
                case -24: strRet = "[-24] - Erro ao gerar PDF"; break;
                case -26: strRet = "[-26] - Erro, servidor retornou consumo indevido"; break;
                case -27: strRet = "[-27] - No foi possvel comunicar com a impressora no fiscal"; break;
                case -30: strRet = "[-30] - Lista no possui itens!"; break;
                case -31: strRet = "[-31] - Quantidade informada no pode ser maior que a quantidade vendida!"; break;
                case -34: strRet = "[-34] - Valor Total j foi pago"; break;
                case -35: strRet = "[-35] - Desconto/ Acrscimo no pode ser igual ou maior que o valor total"; break;
                case -40: strRet = "[-40] - Tag xml no encontrada!"; break;
                case -50: strRet = "[-50] - Tag xml no encontrada!"; break;
                case -51: strRet = "[-51] - Tag xml no encontrada!"; break;
                case -52: strRet = "[-52] - Erro ao gravar em arquivo temporrio!"; break;
                case -54: strRet = "[-54] - Erro na formatao do arquivo TEF"; break;
                case -99: strRet = "[-99] - Parmetro invlido ou ponteiro nulo de parmetro!"; break;
                case -100: strRet = "[-100] - Estado do cupom invlido para execuo o mtodo!"; break;
                case -101: strRet = "[-101] - Erro, informaes necessrias no encontradas no arquivo"; break;
                case -103: strRet = "[-103] - No foram encontradas as DLLs auxiliares (WS_Framework.dll e GNE_Framework.dll)!"; break;
                case -108: strRet = "[-108] - O valor da Nota obriga a Identificao do Cliente."; break;
                case -109: strRet = "[-109] - Chave IDE\\indPres com preenchimento incorreto!"; break;
                case -120: strRet = "[-120] - Encontrada tag invlida!"; break;
                case -121: strRet = "[-121] - Estrutura Invalida!"; break;
                case -122: strRet = "[-122] - Tag obrigatria no foi informada!"; break;
                case -123: strRet = "[-123] - Tag obrigatria no tem valor preenchido!"; break;
                case -124: strRet = "[-124] - Nmero de Srie Invpalido"; break;
                case -125: strRet = "[-125] - Nmero de srie invlido para Contingncia"; break;
                case -130: strRet = "[-130] - NFCe ja aberta!"; break;
                case -131: strRet = "[-131] - NFCe no aberta!"; break;
                case -132: strRet = "[-132] - NFCe no em fase de venda!"; break;
                case -133: strRet = "[-133] - NFCe no em fase de totalizao!"; break;
                case -134: strRet = "[-134] - NFCe no em fase de pagamento!"; break;
                case -135: strRet = "[-135] - NFCe no em fase de encerramento!"; break;
                case -141: strRet = "[-141] - Impressora invlida (modelo deve ser DR700 ou verso incompativel)"; break;
                case -150: strRet = "[-150] - Erro retornado pela Interface TEF"; break;
                case -200: strRet = "[-200] - Impressora selecionada Desconhecida"; break;
                case -213: strRet = "[-213] - Erro, impressora configurada no  Daruma"; break;
                case -220: strRet = "[-220] - Mtodo descontinuado/ Configurao de imposto no realizada"; break;
                case -251: strRet = "[-251] - PIS e COFINS no informados. (Apenas para traduo SAT Habilitada)"; break;
                case -300: strRet = "[-300] - Certificado vencido, no  possvel realizar vendas"; break;
                case -301: strRet = "[-301] - Ocorreu erro na emisso da nota, e UF no permite contingncia"; break;
                case -302: strRet = "[-302] - CNPJ sem movimento no perodo solicitado"; break;
                case -303: strRet = "[-303] - CNPJ no possui o parmetro para a gerao da Leitura X"; break;
                case -304: strRet = "[-304] - No foi possvel agendar exportao. Perodo da data de emisso superior  31 dias"; break;
                default: strRet = "[" + iRetorno.ToString() + "] - Cdigo de retorno no esperado ou no mapeado no exemplo."; break;
            }
            return strRet;
        }

        public static string TrataRetorno_SAT(int iRetorno)
        {
            string strRet = string.Empty;

            switch (iRetorno)
            {
                case 2: strRet = "[2] - Comando de emisso CFe executado com sucesso, falha no envio do xml para backup"; break;
                case 1: strRet = "[1] - Comando executado com sucesso!"; break;
                case 0: strRet = "[0] - Erro genrico./ Erro, comando no executado./ No foi possvel comunicar com a impressora no fiscal./ No tem arquivo de contingncia para enviar."; break;
                case -1: strRet = "[-1] - Erro encontrado na execuo do mtodo - envio backup SAT."; break;
                case -2: strRet = "[-2] - Chave invlida - envio backup SAT."; break;
                case -3: strRet = "[-3] - Falha no schema XML - envio backup SAT."; break;
                case -4: strRet = "[-4] - XML fora do padro - envio backup SAT."; break;
                case -6: strRet = "[-6] - TimeOut, erro de comunicao com o SAT"; break;
                case -7: strRet = "[-7] - Erro ao abrir comunicao com o SAT"; break;
                case -8: strRet = "[-8] - Usurio no Autorizado - envio backup SAT."; break;
                case -9: strRet = "[-9] - Usurio no Licenciado - envio backup SAT."; break;
                case -10: strRet = "[-10] - Documento e Ambiente no identificados - envio backup SAT."; break;
                case -13: strRet = "[-13] - Tipo de documento no identificado - envio backup SAT."; break;
                case -14: strRet = "[-14] - Erro de comunicao com o WebService - envio backup SAT."; break;
                case -16: strRet = "[-16] - Timeout na comunicao com WebService, ou erro de WS no mapeado - envio backup SAT."; break;
                case -27: strRet = "[-27] - Erro genrico na impressora"; break;
                case -34: strRet = "[-34] - O valor total da venda j foi pago."; break;
                case -40: strRet = "[-40] - Tag XML invlida"; break;
                case -50: strRet = "[-50] - Impressora off-Line"; break;
                case -51: strRet = "[-51] - Impressora sem papel"; break;
                case -52: strRet = "[-52] - Erro ao gravar/ ler arquivo temporrio."; break;
                case -54: strRet = "[-54] - Impressora com tampa aberta."; break;
                case -99: strRet = "[-99] - Parmetro invlido ou ponteiro nulo de parmetro"; break;
                case -103: strRet = "[-103] - No foram encontradas bibliotecas auxiliares (GNE e/ou WS)"; break;
                case -120: strRet = "[-120] - Encontrada tag invlida"; break;
                case -121: strRet = "[-121] - Estrutura Invalida"; break;
                case -122: strRet = "[-122] - Tag obrigatria no foi informada"; break;
                case -123: strRet = "[-123] - Tag obrigatria no tem valor preenchido"; break;
                case -130: strRet = "[-130] - CFe j aberto"; break;
                case -131: strRet = "[-131] - CFe no aberto"; break;
                case -132: strRet = "[-132] - CFe no em fase de venda"; break;
                case -133: strRet = "[-133] - CFe no em fase de totalizao"; break;
                case -134: strRet = "[-134] - CFe no em fase de pagamento"; break;
                case -135: strRet = "[-135] - CFe no em fase de encerramento"; break;
                case -136: strRet = "[-136] - CFe em estado invlido para operao"; break;
                case -140: strRet = "[-140] - Biblioteca auxiliar SAT.dll no foi encontrada/carregada"; break;
                case -141: strRet = "[-141] - Impressora invlida (modelo deve ser DR700 ou verso incompativel)"; break;
                case -142: strRet = "[-142] - Resposta Incompleta do SAT"; break;
                case -150: strRet = "[-150] - Erro retornado pela Interface TEF"; break;
                //***** Os cdigos de erro abaixo so retornados pelo SAT  para verificar mais retornos consulte a Especificao de Requisitos do SAT vigente.
                case 1084: strRet = "[1084] - Formato do Certificado Invlido"; break;
                case 1085: strRet = "[1085] - Assinatura do Aplicativo Comercial no confere"; break;
                case 1218: strRet = "[1218] - CF-e-SAT J est cancelado"; break;
                case 1412: strRet = "[1412] - CFe de cancelamento no corresponde a um CFe emitido nos 30 minutos anteriores ao pedido de cancelamento"; break;
                case 1999: strRet = "[1999] - Erro desconhecido"; break;
                case 6001: strRet = "[6001] - Cdigo de ativao invlido"; break;
                case 6002: strRet = "[6002] - SAT ainda no ativado"; break;
                case 6003: strRet = "[6003] - SAT no vinculado ao AC"; break;
                case 6004: strRet = "[6004] - Vinculao do AC no confere"; break;
                case 6005: strRet = "[6005] - Tamanho do CFe superior a 1500KB"; break;
                case 6006: strRet = "[6006] - SAT bloqueado pelo contribuinte"; break;
                case 6007: strRet = "[6007] - SAT bloqueado pela SEFAZ"; break;
                case 6008: strRet = "[6008] - SAT bloqueado por falta de comunicao"; break;
                case 6009: strRet = "[6009] - SAT bloqueado, cdigo de ativao incorreto"; break;
                case 6010: strRet = "[6010] - Erro de validao do contedo"; break;
                case 6098: strRet = "[6098] - SAT em processamento. Tente novamente"; break;
                case 6099: strRet = "[6099] - Erro desconhecido"; break;
                case 7001: strRet = "[7001] - Cdigo de ativao invlido"; break;
                case 7002: strRet = "[7002] - Cupom Invlido"; break;
                case 7003: strRet = "[7003] - SAT bloqueado pelo contribuinte"; break;
                case 7004: strRet = "[7004] - SAT bloqueado pela SEFAZ"; break;
                case 7005: strRet = "[7005] - SAT bloqueado por falta de comunicao"; break;
                case 7006: strRet = "[7006] - SAT bloqueado, cdigo de ativao incorreto"; break;
                case 7007: strRet = "[7007] - Erro de validao do contedo"; break;
                case 7098: strRet = "[7098] - SAT em processamento. Tente novamente"; break;
                case 7099: strRet = "[7099] - Erro desconhecido"; break;
                case 8098: strRet = "[8098] - SAT em processamento. Tente novamente"; break;
                case 8099: strRet = "[8099] - Erro desconhecido"; break;
                case 10001: strRet = "[10001] - Cdigo de ativao invlido"; break;
                case 10098: strRet = "[10098] - SAT em processamento. Tente novamente"; break;
                case 10099: strRet = "[10099] - Erro desconhecido"; break;
                case 13001: strRet = "[13001] - Cdigo de ativao invlido"; break;
                case 13002: strRet = "[13002] - Erro de comunicao com a SEFAZ"; break;
                case 13003: strRet = "[13003] - Assinatura fora do padro informado"; break;
                case 13098: strRet = "[13098] - SAT em processamento. Tente novamente"; break;
                case 13099: strRet = "[13099] - Erro desconhecido"; break;
                default: strRet = "[" + iRetorno.ToString() + "] - Nmero de Erro no identificado... Consulte a Especificao de Requisitos SAT vigente."; break;
            }
            return strRet;
        }


        #region Mtodos DarumaFramework
//************* Mtodos Gerais - XML DFW *************
        [DllImport("DarumaFrameWork.dll")]
        public static extern int eDefinirProduto_Daruma(string strProduto);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int eVerificarVersaoDLL_Daruma(StringBuilder strRetorno);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int eVersoesBibliotecas_Daruma(StringBuilder strRetorno);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int regRetornaValorChave_DarumaFramework(string strProduto, string strChave, StringBuilder strRetorno);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int regAlterarValor_Daruma(string strChave, string strValor);

//************* Mtodos para Mini Impressoras - DUAL *************
        [DllImport("DarumaFrameWork.dll")]
        public static extern int eBuscarPortaVelocidade_DUAL_DarumaFramework();
        [DllImport("DarumaFrameWork.dll")]
        public static extern int rConsultaStatusImpressora_DUAL_DarumaFramework(string strIndice, string stTipoRetorno, StringBuilder strRetorno);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int rModelo_DUAL_DarumaFramework(StringBuilder strModelo);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int rVersaoFW_DUAL_DarumaFramework(StringBuilder strVersaoFW);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int rStatusGaveta_DUAL_DarumaFramework(ref int iStatusGaveta);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int rStatusGuilhotina_DUAL_DarumaFramework();
        [DllImport("DarumaFrameWork.dll")]
        public static extern int rStatusImpressora_DUAL_DarumaFramework();
        [DllImport("DarumaFrameWork.dll")]
        public static extern int iConfigurarGuilhotina_DUAL_DarumaFramework(int iHabilitar, int iQtdeLinha);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int iEnviarBMP_DUAL_DarumaFramework(string strArqOrigem);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int iImprimirArquivo_DUAL_DarumaFramework(string strPath);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int iImprimirTexto_DUAL_DarumaFramework(string strTexto, int iTam);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int iAcionarGaveta_DUAL_DarumaFramework();
        [DllImport("DarumaFrameWork.dll")]
        public static extern int iImprimirBMP_DUAL_DarumaFramework(System.String strArqOrigem);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int eGerarQrCodeArquivo_DUAL_DarumaFramework(string strPath, string strCodigo);
        //************* os mtodos abaixo podem ser substiruidos por regAlterarValor_Daruma
        [DllImport("DarumaFrameWork.dll")]
        public static extern int regVelocidade_DUAL_DarumaFramework(System.String strParametro);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int regTermica_DUAL_DarumaFramework(System.String strParametro);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int regTabulacao_DUAL_DarumaFramework(System.String strParametro);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int regPortaComunicacao_DUAL_DarumaFramework(System.String strParametro);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int regModoGaveta_DUAL_DarumaFramework(System.String strParametro);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int regLinhasGuilhotina_DUAL_DarumaFramework(System.String strParametro);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int regEnterFinal_DUAL_DarumaFramework(System.String strParametro);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int regAguardarProcesso_DUAL_DarumaFramework(System.String strParametro);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int regCodePageAutomatico_DUAL_DarumaFramework(System.String strParametro);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int regZeroCortado_DUAL_DarumaFramework(System.String strParametro);


        //************* Mtodos para NFC-e *************
        [DllImport("DarumaFrameWork.dll")]
        public static extern int regAlterarValor_NFCe_Daruma(String StrTagNFCe, String StrValorTagNFCe);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int regRetornarValor_NFCe_Daruma(String StrTagNFCe, StringBuilder StrValorTagNFCe);

        // Mtodos para Venda - Abertura
        [DllImport("DarumaFrameWork.dll")]
        public static extern int aCFAbrir_NFCe_Daruma(string strCPF, string strNome, string strLgr, string strnro, string strBairro, string strcMun, string strMunicipio, string strUF, string strCEP);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int aCFAbrirNumSerie_NFCe_Daruma(string strNNF, string strNSerie, string strCPF, string strNome, string strLgr, string strNro, string strBairro, string strcMun, string strMunicipio, string strUF, string strCEP);
        // Mtodos para Venda - Imposto do Item
        [DllImport("DarumaFrameWork.dll")]
        public static extern int aCFConfImposto_NFCe_Daruma(string strNomeImposto, string strParametros);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int aCFConfICMS00_NFCe_Daruma(string strOrig, string strCST, string strModBC, string strpICMS);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int aCFConfICMS20_NFCe_Daruma(string strOrig, string strCST, string strModBC, string strpRedBC, string strpICMS);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int aCFConfICMS40_NFCe_Daruma(string strOrig, string strCST, string strvICMSDeson, string strMotDesICMS);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int aCFConfICMS60_NFCe_Daruma(string strOrig, string strCST, string strvBCSTRet, string strvICMSSTRet);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int aCFConfICMS90_NFCe_Daruma(string strOrig, string strCST, string strModBC, string strpRedBC, string strpICMS, string strModBCST, string strpMVAST, string strpRedBCST, string strvBCST, string strpICMSST, string strvICMSDeson, string strmotDesICMS);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int aCFConfICMSSN102_NFCe_Daruma(string strOrig, string strCSOSN);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int aCFConfICMSSN500_NFCe_Daruma(string strOrig, string strCSOSN, string strvBCSTRet, string strvICMSSTRet);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int aCFConfICMSSN900_NFCe_Daruma(string strOrig, string strCSOSN, string strmodBC, string strpRedBC, string strpICMS, string strmodBCST, string strpMVAST, string strpRedBCST, string strvBCST, string strpICMSST, string strvICMSST, string strpCredSN, string strvCredICMSSN);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int aCFConfPisAliq_NFCe_Daruma(string strCST, string strpPIS);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int aCFConfPisQtde_NFCe_Daruma(string strCST, string strvAliqProd);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int aCFConfPisNT_NFCe_Daruma(string strCST);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int aCFConfPisOutr_NFCe_Daruma(string strCST, string strpPIS, string strvAliqProd);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int aCFConfCofinsAliq_NFCe_Daruma(string strCST, string strpCOFINS);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int aCFConfCofinsQtde_NFCe_Daruma(string strCST, string strvAliqProd);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int aCFConfCofinsNT_NFCe_Daruma(string strCST);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int aCFConfCofinsOutr_NFCe_Daruma(string strCST, string strpCOFINS, string strvAliqProd);
        // Mtodos para Venda - Informaes Adicionais de Item
        [DllImport("DarumaFrameWork.dll")]
        public static extern int aCFValorLeiImposto_NFCe_Daruma(string strValor);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int aCFConfLeiImposto_NFCe_Daruma(string strNCM, string strEx, string strTipo, string strNacionalFed, string strImportadoFed, string strEstadual, string strMun);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int aCFConfCombustivel_NFCe_Daruma(string strcProdANP, string strpMixGN, string strCODIF, string strqTemp, string strUFCons, string strqBCProd, string strvAliqProd, string strvCIDE, string strnBico, string strnBomba, string strnTanque, string strvEncInicial, string strvEncFinal, string strUsoFuturo);
        // Mtodos para Venda - Vender o Item
        [DllImport("DarumaFrameWork.dll")]
        public static extern int aCFVender_NFCe_Daruma(string strCargaTributaria, string strQuantidade, string strPrecoUnitario, string strTipoDescAcresc, string strValorDescAcresc, string strCodigoItem, string strUnidadeMedida, string strDescricaoItem);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int aCFVenderCompleto_NFCe_Daruma(string strAliquota, string strQuantidade, string strPrecoUnitario, string strTipoDescAcresc, string strValorDescAcresc, string strCodigoItem, string strNCMm, string strCFOP, string strUnidadeMedida, string strDescricaoItem, string strUsoFuturo);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int aCFVenderXml_NFCe_Daruma(string strXML);
        // Mtodos para Venda - Desconto/ Acrescimo Item
        [DllImport("DarumaFrameWork.dll")]
        public static extern int aCFLancarAcrescimoItem_NFCe_Daruma(string strNumItem, string strTipoAcresc, string strValorAcresc);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int aCFLancarDescontoItem_NFCe_Daruma(string strNumItem, string strTipoDesc, string strValorDesc);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int aCFCancelarAcrescimoItem_NFCe_Daruma(string strNumItem);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int aCFCancelarDescontoItem_NFCe_Daruma(string strNumItem);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int aCFCancelarItemParcial_NFCe_Daruma(string strNumItem, string strQuant);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int aCFCancelarItem_NFCe_Daruma(string strNumItem);
        // Mtodos para Venda - Totalizar
        [DllImport("DarumaFrameWork.dll")]
        public static extern int aCFTotalizar_NFCe_Daruma(string strTipoDescAcresc, string strValorDescAcresc);
        // Mtodos para Venda - Pagamento da Venda
        [DllImport("DarumaFrameWork.dll")]
        public static extern int aCFIdentificarCartao_NFCe_Daruma(string strCNPJ, string strBandeira, string strAutorizacao);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int aCFEfetuarPagamento_NFCe_Daruma(string strFormaPgto, string strValor);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int aCFEfetuarPagamentoCartao_NFCe_Daruma(string strTipoCartao, string strValorPgto, string strTipoIntegracao, string strCNPJCred, string strCodBandeira, string strAutorizacao, string strUsoFuturo);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int aCFEstornarPagamento_NFCe_Daruma(string strNFormaPagtoEstornado, string strFormaPagtoEfetivado, string strValor);
        // Mtodos para Venda - Outras infos venda
        [DllImport("DarumaFrameWork.dll")]
        public static extern int aCFIdentificarConsumidor_NFCe_Daruma(string strCPF, string strNome, string strLgr, string strNro, string strBairro, string strcMun, string strMunicipio, string strUF, string strCEP, string strEmail);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int aCFIdentificarTransportadora_NFCe_Daruma(string strCPF_CNPJ, string strNome, string strIE, string strEndereco, string strMunicipio, string strUF);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int aCFMsgPromocional_NFCe_Daruma(string strMsgPromocional, string strTextoLivre);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int aCFConfRastro_NFCe_Daruma(string strParametros);
        // Mtodos para Venda - Encerrar/ Fechar Venda
        [DllImport("DarumaFrameWork.dll")]
        public static extern int tCFEncerrar_NFCe_Daruma(string strMsgPromocional);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int tCFEncerrarConfigMsg_NFCe_Daruma(string strMsgPromo, string strMsgFisco, string strUsoFuturo);
        // Mtodos para Descarte/ Cancelamento/ Inutilizao de Venda
        [DllImport("DarumaFrameWork.dll")]
        public static extern int tCFCancelar_NFCe_Daruma(string strNNF, string strNSerie, string strChAcesso, string strProtAutorizacao, string strJustificativa);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int tCFCancelarParametrizado_NFCe_Daruma(string strNNF, string strNSerie, string strChAcesso, string strProtAutorizacao, string strJustificativa, string strParametros);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int tCFInutilizar_NFCe_Daruma(string strnNFInic, string strnNFFim, string strNSerie, string strJustificativa);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int tDescartarNota_NFCe_Daruma(string strNF, string strSerie, string strOpcao);
        // Mtodos para Impressao
        [DllImport("DarumaFrameWork.dll")]
        public static extern int iCFImprimir_NFCe_Daruma(string strPathXMLVenda, string strPathRetornoWS, string strLinkQrCode, int iNumColunas, int iTipoNF);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int iCFImprimirParametrizado_NFCe_Daruma(string strPathXMLVenda, string strPathRetornoWS, string strLinkQrCode, int iNumColunas, int iTipoNF, string strParametros);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int iCFReImprimir_NFCe_Daruma(string strNNF, string strSerie, string strChaveAcesso);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int iTEFImprimirResposta_NFCe_Daruma(string strPathNomeArquivo, int iNumeroVias, int iCorteEntreVias, int iTravarTeclado);
        // Mtodos de Retornos e Status
        [DllImport("DarumaFrameWork.dll")]
        public static extern int rLeituraX_NFCe_Daruma(string strData, string strSrie, string strTipoRetorno, StringBuilder strRetorno);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int rRecuperarXML_NFCe_Daruma(string strDataInicial, string strDataFinal, string strStatusNF, string strPathXML);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int rRetornarInformacao_NFCe_Daruma(string strTipoIntervalo, string strInic, string strFim, string strSerie, string strChaveAcesso, string strInfoConsulta, StringBuilder StrResposta);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int rRetornarInformacaoArq_NFCe_Daruma(string strTipoIntervalo, string strInic, string strFim, string strSerie, string strChaveAcesso, string strInfoConsulta, string strPathArqResposta);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int rURLQrcode_NFCe_Daruma(StringBuilder strRetornoUrl);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int rAvisoErro_NFCe_Daruma(StringBuilder StrCodigo, StringBuilder StrMensagem);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int rInfoEstendida_NFCe_Daruma(string strIndice, StringBuilder strRetorno);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int rStatusWS_NFCe_Daruma();
        [DllImport("DarumaFrameWork.dll")]
        public static extern int rStatusImpressora_NFCe_Daruma();
        [DllImport("DarumaFrameWork.dll")]
        public static extern int rValidadeCertificado_NFCe_Daruma(StringBuilder StrDataVenc, StringBuilder StrDiasRestante);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int rCFVerificarStatus_NFCe_Daruma();
        // Mtodos Especiais
        [DllImport("DarumaFrameWork.dll")]
        public static extern int eAtualizarEnviarXML_NFCe_Daruma(string strPathXML, string strParametros, string strEnviaXML);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int eEmiteOffline_NFCe_Daruma(string strOpcao);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int eAjustarDataHora_NFCe_Daruma();
        [DllImport("DarumaFrameWork.dll")]
        public static extern int tCFEnviar_NFCe_Daruma(string strEmpPK, string strEmpCK, string strDados, string strDadosParam, string strDadosInfo, string strAux);
        // Mtodos de Contigencia Offline
        [DllImport("DarumaFrameWork.dll")]
        public static extern int tCFCancelarOffline_NFCe_Daruma(string strNNF, string strNSerie, string strChAcesso, string strJustificativa);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int tEnviarContingenciaOffline_NFCe_Daruma(int iQtdDocsContingencia);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int tEnviarContingenciaCancOffline_NFCe_Daruma(int iQtdDocsCancContingencia);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int tEnvioUnitContingenciaOffline_NFCe_Daruma(StringBuilder strCNPJEmit, StringBuilder strSerie, StringBuilder strnNF, StringBuilder strProtocolo, StringBuilder strChaveAcesso, StringBuilder strSitCodigo);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int tEnvioUnitContingenciaCancOffline_NFCe_Daruma(StringBuilder strCNPJEmit, StringBuilder strSerie, StringBuilder strnNF, StringBuilder strProtocolo, StringBuilder strChaveAcesso, StringBuilder strSitCodigo);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int rNumDocsContingencia_NFCe_Daruma();
        [DllImport("DarumaFrameWork.dll")]
        public static extern int rNumDocsContingenciaCanc_NFCe_Daruma();
        [DllImport("DarumaFrameWork.dll")]
        public static extern int rRetornarInformacaoContingencia_NFCe_Daruma(string strChaveAcesso, string strNumNota, string strSerie, string strInfoConsulta, StringBuilder strRetorno);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int rUltimaCtg_NFCe_Daruma(StringBuilder strUltimaCtg, StringBuilder strTipoContingencia);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int tEnvioUnitCtg_NFCe_Daruma(string strUltimaCtg, StringBuilder StrCNPJEmit, StringBuilder StrSerie, StringBuilder StrnNF, StringBuilder StrProtocolo, StringBuilder StrChaveAcesso, StringBuilder StrSitCodigo);
        // Mtodos NF-e
        [DllImport("DarumaFrameWork.dll")]
        public static extern int tEnviar_NFe_Daruma(string strDocumentos, string strParametros, int iQtdeDoc, int iTipoRetorno, StringBuilder strRetorno);
        // Mtodos de Transao TEF
        [DllImport("DarumaFrameWork.dll")]
        public static extern int tTransacaoAdministrativaTEF_NFCe_Daruma(string strDocFiscal, string strTipoIdentificacaoCliente, string strIdentificacaoCliente, string strInfoAdicional, string strTaxaServico, string strTipoCartao, string strUsoFuturo);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int tTransacaoCancelamentoTEF_NFCe_Daruma(string strDocFiscal, string strValorTotal, string strTipoIdentificacaoCliente, string strIdentificacaoCliente, string strNSU, string strRedeAdquirente, string strDataComprovante, string strHoraComprovante, string strInfoAdicional, string strTaxaServico, string strTipoCartao, string strUsoFuturo);

        //************* Mtodos para SAT *************
        [DllImport("DarumaFrameWork.dll")]
        public static extern int regAlterarValor_SAT_Daruma(string strTagSAT, string strValorTagSAT);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int regRetornarValor_SAT_Daruma(string strTagSAT, StringBuilder strValorRetTagSAT);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int tCFeEnviar_SAT_Daruma(string strTagsSAT);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int tCFeAssociarAssinatura_SAT_Daruma(string strTagsSAT);
        // Mtodos para Venda - Abertura
        [DllImport("DarumaFrameWork.dll")]
        public static extern int aCFeAbrir_SAT_Daruma(string strTagsSAT);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int aCFAbrir_SAT_Daruma(string strCPF, string strNome, string strEndereco);
        // Mtodos para Venda - Venda do Item
        [DllImport("DarumaFrameWork.dll")]
        public static extern int aCFConfImposto_SAT_Daruma(string strTipoImposto, string strParametrosImposto);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int aCFeVender_SAT_Daruma(string strTagsSAT);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int aCFVender_SAT_Daruma(string strCargaTributaria, string strQuantidade, string strPrecoUnitario, string strTipoDescAcresc, string strValorDescAcresc, string strCodigoItem, string strUnidadeMedida, string strDescricaoItem);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int aCFVenderCompleto_SAT_Daruma(string strAliquota, string strQuantidade, string strPrecoUnitario, string strTipoDescAcresc, string strValorDescAcresc, string strCodigoItem, string strNCM, string strCFOP, string strUnidadeMedida, string strDescricaoItem, string strUsoFuturo);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int aCFeCancelarItem_SAT_Daruma(int iNumItem);
        // Mtodos para Venda - Totalizar
        [DllImport("DarumaFrameWork.dll")]
        public static extern int aCFeTotalizar_SAT_Daruma(string strTagsSAT);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int aCFTotalizar_SAT_Daruma(string strTipoDescAcresc, string strValorDescAcresc);
        // Mtodos para Venda - Pagamento
        [DllImport("DarumaFrameWork.dll")]
        public static extern int aCFeEfetuarPagamento_SAT_Daruma(string strTagsSAT);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int aCFEfetuarPagamento_SAT_Daruma(string strFormaPgto, string strValor, string strInfoAdicional);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int aCFeCancelarFormaPagamento_SAT_Daruma(int iNumFormaPagamento);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int aCFeEstornarPagamento_SAT_Daruma(string strTagsEstorno);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int aCFEstornarPagamento_SAT_Daruma(string strFormaPgtoEstorno, string strFormaPgtoEfetivado, string strValor);
        // Mtodos para Venda - Encerramento
        [DllImport("DarumaFrameWork.dll")]
        public static extern int aCFValorLeiImposto_SAT_Daruma(string strValorImposto);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int tCFeEncerrar_SAT_Daruma(string strTagsSAT);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int tCFEncerrar_SAT_Daruma(string strCupomAdicional, string strInfoAdic);
        // Mtodos para Cancelamento de Venda
        [DllImport("DarumaFrameWork.dll")]
        public static extern int tCFeCancelar_SAT_Daruma();
        [DllImport("DarumaFrameWork.dll")]
        public static extern int tCFeCancelarParametrizado_SAT_Daruma(string strCpfCnpjConsumidor, string strChaveConsulta);
        // Mtodos para Retornos e Status
        [DllImport("DarumaFrameWork.dll")]
        public static extern int rVerificarComunicacao_SAT_Daruma();
        [DllImport("DarumaFrameWork.dll")]
        public static extern int rConsultarStatus_SAT_Daruma(StringBuilder strRetornoSAT);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int rConsultarStatusEspecifico_SAT_Daruma(string strCampo, StringBuilder strRetornoSAT);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int rConsultarArqCopSeguranca_SAT_Daruma(StringBuilder strArqCopSeg);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int rInfoEstendida_SAT_Daruma(string strIndice, StringBuilder strRetorno);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int rAvisoErro_SAT_Daruma(StringBuilder strCodigo, StringBuilder strMensagem);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int rCFVerificarStatus_SAT_Daruma();
        [DllImport("DarumaFrameWork.dll")]
        public static extern int rNumDocsContingencia_SAT_Daruma();
        [DllImport("DarumaFrameWork.dll")]
        public static extern int tEnviarContingencia_SAT_Daruma(int intNumDocs);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int tEnviarXML_SAT_Daruma(string pszPathXML);

        // Mtodos de Impresso
        [DllImport("DarumaFrameWork.dll")]
        public static extern int iReimprimirUltimoCFe_SAT_Daruma();
        [DllImport("DarumaFrameWork.dll")]
        public static extern int iImprimirCFe_SAT_Daruma(string strPathXmlSAT, string strTipo);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int iTEFImprimirResposta_SAT_Daruma(string strPathNomeArquivo, int iNumeroVias, int iCorteEntreVias, int iTravarTeclado);


        #region Mtodos Impressora Fiscal
        //FUNCOES ECF 
        [DllImport("DarumaFrameWork.dll")]
        public static extern int iCFAbrir_ECF_Daruma(string strCPF, string strNome, string strEndereco);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int iCFAbrirPadrao_ECF_Daruma();
        [DllImport("DarumaFrameWork.dll")]
        public static extern int iCFVender_ECF_Daruma(string strCargaTributaria, string strQuantidade, string strPrecoUnitario, string strTipoDescAcresc, string strValorDescAcresc, string strCodigoItem, string strUnidadeMedida, string strDescricaoItem);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int iCFVenderSemDesc_ECF_Daruma(string strCargaTributaria, string strQuantidade, string strPrecoUnitario, string strCodigoItem, string strUnidadeMedida, string strDescricaoItem);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int iCFVenderResumido_ECF_Daruma(string strCargaTributaria, string strPrecoUnitario, string strCodigoItem, string strDescricaoItem);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int fnCFLancarDescAcrescItem_ECF_Daruma(string strNumItem, string strTipoDescAcresc, string strValorDescAcresc);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int iCFLancarAcrescimoItem_ECF_Daruma(string strNumItem, string strTipoDescAcresc, string strValorDescAcresc);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int iCFLancarDescontoItem_ECF_Daruma(string strNumItem, string strTipoDescAcresc, string strValorDescAcresc);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int iCFLancarAcrescimoUltimoItem_ECF_Daruma(string strTipoDescAcresc, string strValorDescAcresc);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int iCFLancarDescontoUltimoItem_ECF_Daruma(string strTipoDescAcresc, string strValorDescAcresc);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int iCFCancelarItem_ECF_Daruma(string strNumItem);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int iCFCancelarUltimoItem_ECF_Daruma();
        [DllImport("DarumaFrameWork.dll")]
        public static extern int iCFCancelarItemParcial_ECF_Daruma(string strNumItem, string strQuantidade);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int iCFCancelarUltimoItemParcial_ECF_Daruma(string strQuantidade);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int iCFCancelarDescontoItem_ECF_Daruma(string strNumItem);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int iCFCancelarDescontoUltimoItem_ECF_Daruma();
        [DllImport("DarumaFrameWork.dll")]
        public static extern int iCFCancelarAcrescimoItem_ECF_Daruma(string strNumItem);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int iCFCancelarAcrescimoUltimoItem_ECF_Daruma();
        [DllImport("DarumaFrameWork.dll")]
        public static extern int iCFTotalizarCupom_ECF_Daruma(string strTipoDescAcresc, string strValorDescAcresc);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int iCFTotalizarCupomPadrao_ECF_Daruma();
        [DllImport("DarumaFrameWork.dll")]
        public static extern int iCFCancelarDescontoSubtotal_ECF_Daruma();
        [DllImport("DarumaFrameWork.dll")]
        public static extern int iCFCancelarAcrescimoSubtotal_ECF_Daruma();
        [DllImport("DarumaFrameWork.dll")]
        public static extern int iCFEfetuarPagamentoPadrao_ECF_Daruma();
        [DllImport("DarumaFrameWork.dll")]
        public static extern int iCFEfetuarPagamentoFormatado_ECF_Daruma(string strFormaPgto, string strValor);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int iCFEfetuarPagamento_ECF_Daruma(string strFormaPgto, string strValor, string strInfoAdicional);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int rCFSaldoAPagar_ECF_Daruma(StringBuilder strValor);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int rCFSubTotal_ECF_Daruma(StringBuilder strValor);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int iCFEncerrarPadrao_ECF_Daruma();
        [DllImport("DarumaFrameWork.dll")]
        public static extern int iCFEncerrarConfigMsg_ECF_Daruma(string strMensagem);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int iCFEncerrar_ECF_Daruma(string strCupomAdicional, string strMensagem);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int iCFEncerrarResumido_ECF_Daruma();
        [DllImport("DarumaFrameWork.dll")]
        public static extern int iCFEmitirCupomAdicional_ECF_Daruma();
        [DllImport("DarumaFrameWork.dll")]
        public static extern int iCFCancelar_ECF_Daruma();
        [DllImport("DarumaFrameWork.dll")]
        public static extern int rCFVerificarStatus_ECF_Daruma(StringBuilder strStatusCF, ref int iStatusCF);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int rCFVerificarStatusInt_ECF_Daruma(ref int iStatusCF);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int rCFVerificarStatusStr_ECF_Daruma(StringBuilder strStatusCF);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int iCFIdentificarConsumidor_ECF_Daruma(string strNome, string strEndereco, string strDoc);
		[DllImport("DarumaFrameWork.dll")]
        public static extern int rCMEfetuarCalculo_ECF_Daruma(StringBuilder strISS, StringBuilder strICMS);
    	[DllImport("DarumaFrameWork.dll")]
        public static extern int iCFBPAbrir_ECF_Daruma(string strOrigem, string strDestino, string strUFDestino, string strPercurso, string strPrestadora, string strPlataforma, string strPoltrona, string strModalidadetransp, string strCategoriaTransp, string strDataEmbarque, string strRGPassageiro, string strNomePassageiro, string strEnderecoPassageiro);
    	[DllImport("DarumaFrameWork.dll")]
        public static extern int iCFBPVender_ECF_Daruma(string strAliquota, string strValor, string strTipoDescAcresc, string strValorDescAcresc, string strDescricao);
    	[DllImport("DarumaFrameWork.dll")]
        public static extern int confCFBPProgramarUF_ECF_Daruma(string strUF);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int confCFNCM_ECF_Daruma(string strCodNCM, string strTipo);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int rCFVrImposto_ECF_Daruma(string strNumItem, StringBuilder strNCM);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int rGerarMapaResumo_ECF_Daruma();
		[DllImport("DarumaFrameWork.dll")]
        public static extern int rEfetuarDownloadMFD_ECF_Daruma(string strTipo, string strInicial, string strFinal, string strNomeArquivo);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int rGerarEspelhoMFD_ECF_Daruma(string strTipo, string strInicial, string strFinal);
		[DllImport("DarumaFrameWork.dll")]
        public static extern int rEfetuarDownloadMF_ECF_Daruma(string strNomeArquivo);
		[DllImport("DarumaFrameWork.dll")]
        public static extern int rEfetuarDownloadTDM_ECF_Daruma(string strTipo, string strInicial, string strFinal, string strNomeArquivo);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int rGerarRelatorio_ECF_Daruma(string strRelatorio, string strTipo, string strInicial, string strFinal);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int rGerarMFD_ECF_Daruma(string strTipo, string strInicial, string strFinal);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int rGerarMF_ECF_Daruma(string strTipo, string strInicial, string strFinal);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int rGerarTDM_ECF_Daruma(string strTipo, string strInicial, string strFinal);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int rGerarNFP_ECF_Daruma(string strTipo, string strInicial, string strFinal);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int rGerarSPED_ECF_Daruma(string strTipo, string strInicial, string strFinal);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int rGerarSINTEGRA_ECF_Daruma(string strTipo, string strInicial, string strFinal);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int rGerarRelatorioOffline_ECF_Daruma(string szRelatorio, string szTipo, string szInicial, string szFinal, string szArquivo_MF, string szArquivo_MFD, string szArquivo_INF);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int rAssinarRSA_ECF_Daruma(string strPathArquivo, string strChavePrivada, StringBuilder strAssinaturaGerada);
		[DllImport("DarumaFrameWork.dll")]
        public static extern int rCalcularMD5_ECF_Daruma(string strPathArquivo, StringBuilder strMD5GeradoHex, StringBuilder strMD5GeradoAscii);
		[DllImport("DarumaFrameWork.dll")]
        public static extern int iImprimirCodigoBarras_ECF_Daruma(string strTipo, string strLargura, string strAltura, string strImprTexto, string strCodigo, string strOrientacao, string strTextoLivre); 
        [DllImport("DarumaFrameWork.dll")]
        public static extern int iRGAbrir_ECF_Daruma(string strNomeRG);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int iRGAbrirIndice_ECF_Daruma(int iIndiceRG);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int iRGAbrirPadrao_ECF_Daruma();
        [DllImport("DarumaFrameWork.dll")]
        public static extern int iRGImprimirTexto_ECF_Daruma(string strTexto);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int iRGFechar_ECF_Daruma();
        [DllImport("DarumaFrameWork.dll")]
        public static extern int iRGImprimirArquivo_ECF_Daruma(string strPath);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int iCCDAbrir_ECF_Daruma(string strFormaPgto, string strParcelas, string strDocOrigem, string strValor, string strCPF, string strNome, string strEndereco);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int iCCDAbrirSimplificado_ECF_Daruma(string strFormaPgto, string strParcelas, string strDocOrigem, string strValor);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int iCCDAbrirPadrao_ECF_Daruma();
        [DllImport("DarumaFrameWork.dll")]
        public static extern int iCCDImprimirTexto_ECF_Daruma(string strTexto);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int iCCDImprimirArquivo_ECF_Daruma(string strArqOrigem);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int iCCDFechar_ECF_Daruma();
        [DllImport("DarumaFrameWork.dll")]
        public static extern int iCCDAbrirEstorno_ECF_Daruma(string strCOO, string strCPF, string strNome, string strEndereco);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int iCCDEstornarPadrao_ECF_Daruma();
        [DllImport("DarumaFrameWork.dll")]
        public static extern int iCCDEstornar_ECF_Daruma(string strCOO, string strCPF, string strNome, string strEndereco);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int iCCDSegundaVia_ECF_Daruma();
        [DllImport("DarumaFrameWork.dll")]
        public static extern int iTEF_ImprimirResposta_ECF_Daruma(String szArquivo, Boolean bTravarTeclado);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int iTEF_ImprimirRespostaCartao_ECF_Daruma(string szArquivo, Boolean bTravarTeclado, string szForma, string szValor);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int iTEF_Fechar_ECF_Daruma();
        [DllImport("DarumaFrameWork.dll")]
        public static extern int eTEF_EsperarArquivo_ECF_Daruma(String szArquivo, int iTempo, Boolean bTravar);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int eTEF_TravarTeclado_ECF_Daruma(Boolean bTravar);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int eTEF_SetarFoco_ECF_Daruma(String szNomeTela); 
        [DllImport("DarumaFrameWork.dll")]
        public static extern int iMFLerSerial_ECF_Daruma(string strInicial, string strFinal);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int iMFLer_ECF_Daruma(string strInicial, string strFinal);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int iCNFAbrir_ECF_Daruma(string strCPF, string strNome,  string strEndereco);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int iCNFAbrirPadrao_ECF_Daruma();
        [DllImport("DarumaFrameWork.dll")]
        public static extern int iCNFReceber_ECF_Daruma(string strIndice, string strValor,  string strTipoDescAcresc, string strValorDescAcresc);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int iCNFReceberSemDesc_ECF_Daruma(string strIndice, string strValor);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int iCNFCancelarItem_ECF_Daruma(string strNumItem);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int iCNFCancelarUltimoItem_ECF_Daruma();
        [DllImport("DarumaFrameWork.dll")]
        public static extern int iCNFCancelarAcrescimoItem_ECF_Daruma(string strNumItem);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int iCNFCancelarAcrescimoUltimoItem_ECF_Daruma();
        [DllImport("DarumaFrameWork.dll")]
        public static extern int iCNFCancelarDescontoItem_ECF_Daruma(string strNumItem);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int iCNFCancelarDescUltimoItem_ECF_Daruma();
        [DllImport("DarumaFrameWork.dll")]
        public static extern int iCNFTotalizarComprovante_ECF_Daruma(string strTipoDescAcresc, string strValorDescAcresc);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int iCNFTotalizarComprovantePadrao_ECF_Daruma();
        [DllImport("DarumaFrameWork.dll")]
        public static extern int iCNFCancelarAcrescimoSubtotal_ECF_Daruma();
        [DllImport("DarumaFrameWork.dll")]
        public static extern int iCNFCancelarDescontoSubtotal_ECF_Daruma();
        [DllImport("DarumaFrameWork.dll")]
        public static extern int iCNFEfetuarPagamento_ECF_Daruma(string strFormaPgto, string strValor, string strInfoAdicional);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int iCNFEfetuarPagamentoFormatado_ECF_Daruma(string strFormaPgto, string strValor);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int iCNFEfetuarPagamentoPadrao_ECF_Daruma();
        [DllImport("DarumaFrameWork.dll")]
        public static extern int iCNFEncerrar_ECF_Daruma(string strMensagem);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int iCNFEncerrarPadrao_ECF_Daruma();
        [DllImport("DarumaFrameWork.dll")]
        public static extern int iCNFCancelar_ECF_Daruma();
        [DllImport("DarumaFrameWork.dll")]
        public static extern int eEjetarCheque_ECF_Daruma();
        [DllImport("DarumaFrameWork.dll")]
        public static extern int confCorrigirGeometria_CHEQUE_Daruma(string strNumeroBanco, string strDistValorNumerico, string strColunaValorNumerico,
        string strDistPrimExtenso,string strColunaPrimExtenso,string strDistSegExtenso,string strColunaSegExtenso,string strDistFavorecido,
        string strColunaFavorecido,string strDistCidade,string strColunaCidade,string strColunaDia,string strColunaMes,string strColunaAno,string strLinhaAutenticacao,
        string strColunaAutenticacao);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int iAtributo_CHEQUE_Daruma(string strModo); 
        [DllImport("DarumaFrameWork.dll")]
        public static extern int iAutenticar_CHEQUE_Daruma(string strPosicao, string strTexto); 
        [DllImport("DarumaFrameWork.dll")]
        public static extern int  iImprimir_CHEQUE_Daruma(string strNumeroBanco, string strCidade, string strData,string strNomeFavorecido,
        string strTextoFrente, string strValorCheque);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int iImprimirVerso_CHEQUE_Daruma(string strTexto); 
        [DllImport("DarumaFrameWork.dll")]
        public static extern int iImprimirVertical_CHEQUE_Daruma(string strNumeroBanco,string strCidade,string strData, string strNomeFavorecido,
        string strTextoFrente, string strValorCheque);
 
        [DllImport("DarumaFrameWork.dll")]
        public static extern int iEstornarPagamento_ECF_Daruma(string strFormaPgtoEstornado, string strFormaPgtoEfetivado,  string strValor, string strInfoAdicional);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int fnLeituraX_ECF_Daruma(int iTipo, string strCaminho);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int iLeituraX_ECF_Daruma();
        [DllImport("DarumaFrameWork.dll")]
        public static extern int rLeituraX_ECF_Daruma();
        [DllImport("DarumaFrameWork.dll")]
        public static extern int rLeituraXCustomizada_ECF_Daruma(string strCaminho);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int iSangriaPadrao_ECF_Daruma();
        [DllImport("DarumaFrameWork.dll")]
        public static extern int iSangria_ECF_Daruma(string strValor, string strMensagem);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int iSuprimentoPadrao_ECF_Daruma();
        [DllImport("DarumaFrameWork.dll")]
        public static extern int iSuprimento_ECF_Daruma(string strValor, string strMensagem);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int iReducaoZ_ECF_Daruma(string NamelessParameter1, string NamelessParameter2);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int eAbrirGaveta_ECF_Daruma();
        [DllImport("DarumaFrameWork.dll")]
        public static extern int eSinalSonoro_ECF_Daruma(string SinalSonoro);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int confCadastrarPadrao_ECF_Daruma(string strCadastrar, string strValor);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int confIndiceCadastrar_ECF_Daruma(string strCadastrar, string strValor, string strSeparador, string strIndice);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int confCadastrar_ECF_Daruma(string strCadastrar, string strValor, string strSeparador);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int confHabilitarHorarioVerao_ECF_Daruma();
        [DllImport("DarumaFrameWork.dll")]
        public static extern int confDesabilitarHorarioVerao_ECF_Daruma();
		[DllImport("DarumaFrameWork.dll")]
        public static extern int confProgramarOperador_ECF_Daruma(string strValor);
		[DllImport("DarumaFrameWork.dll")]
        public static extern int confProgramarIDLoja_ECF_Daruma(string strValor);
		[DllImport("DarumaFrameWork.dll")]
        public static extern int confProgramarAvancoPapel_ECF_Daruma(string strSepEntreLinhas, string strSepEntreDoc, string strLinhasGuilhotina, string strGuilhotina, string strImpClicheAntecipada);
		[DllImport("DarumaFrameWork.dll")]
        public static extern int confHabilitarModoPreVenda_ECF_Daruma();
		[DllImport("DarumaFrameWork.dll")]
        public static extern int confDesabilitarModoPreVenda_ECF_Daruma();
        [DllImport("DarumaFrameWork.dll")]
        public static extern int rLerAliquotas_ECF_Daruma(StringBuilder cAliquotas);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int rLerCNF_ECF_Daruma(StringBuilder cAliquotas);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int rCodigoModeloFiscal_ECF_Daruma(StringBuilder cValor);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int rLerMeiosPagto_ECF_Daruma(StringBuilder strRelatorios);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int rLerRG_ECF_Daruma(StringBuilder strRelatorios);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int rLerDecimais_ECF_Daruma(StringBuilder strDecimalQtde, StringBuilder strDecimalValor, ref int piDecimalQtde, ref int piDecimalValor);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int rLerDecimaisInt_ECF_Daruma(ref int piDecimalQtde, ref int piDecimalValor);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int rLerDecimaisStr_ECF_Daruma(StringBuilder strDecimalQtde, StringBuilder strDecimalValor);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int rDataHoraImpressora_ECF_Daruma(StringBuilder strData, StringBuilder strHora);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int rVerificarImpressoraLigada_ECF_Daruma();
        [DllImport("DarumaFramework.dll")]
        public static extern int rMinasLegal_ECF_Daruma(StringBuilder sMinasLegal);
        [DllImport("DarumaFramework.dll")]
        public static extern int rVerificaStatusCupom_ECF_Daruma(StringBuilder sStatus);
        [DllImport("DarumaFramework.dll")]
        public static extern int rRetornarVendaBruta_ECF_Daruma(StringBuilder strRetorno);
        [DllImport("DarumaFramework.dll")]
        public static extern int rRetornarVendaLiquida_ECF_Daruma(StringBuilder strRetorno);
        [DllImport("DarumaFramework.dll")]
        public static extern int rCompararDataHora_ECF_Daruma(ref int iDiferenca);
        [DllImport("DarumaFramework.dll")]
        public static extern int rInfoCNF_ECF_Daruma(StringBuilder strRetorno);
        [DllImport("DarumaFramework.dll")]
        public static extern int rRGVerificarStatus_ECF_Daruma(StringBuilder strStatusRG, int iStatusRG); 

        [DllImport("DarumaFrameWork.dll")]
        public static extern int rStatusImpressora_ECF_Daruma(StringBuilder strStatus);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int rStatusImpressoraStr_ECF_Daruma(StringBuilder strStatus);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int rStatusImpressoraInt_ECF_Daruma(ref int iStatusEcf);

        [DllImport("DarumaFrameWork.dll")]
        public static extern int rInfoEstentida_ECF_Daruma(int iIndice, StringBuilder strInfoEx);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int rInfoEstentida1_ECF_Daruma(StringBuilder strInfoEx);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int rInfoEstentida2_ECF_Daruma(StringBuilder cInfoEx);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int rInfoEstentida3_ECF_Daruma(StringBuilder cInfoEx);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int rInfoEstentida4_ECF_Daruma(StringBuilder cInfoEx);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int rInfoEstentida5_ECF_Daruma(StringBuilder cInfoEx);

        [DllImport("DarumaFrameWork.dll")]
        public static extern int rVerificarReducaoZ_ECF_Daruma(StringBuilder strRzPendente);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int rStatusUltimoCmd_ECF_Daruma(StringBuilder strErro, StringBuilder strAviso, ref int iErro, ref int iAviso);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int rStatusUltimoCmdInt_ECF_Daruma(ref int iErro, ref int iAviso);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int rUltimoCMDEnviado_ECF_Daruma(StringBuilder strUltimoCMD);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int rTipoUltimoDocumentoStr_ECF_Daruma(StringBuilder strUltimoDOC);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int rTipoUltimoDocumentoInt_ECF_Daruma(StringBuilder strUltimoDOC);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int iRelatorioConfiguracao_ECF_Daruma();

        [DllImport("DarumaFrameWork.dll")]
        public static extern int rStatusGaveta_ECF_Daruma(ref int iStatus);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int rConsultaStatusImpressoraInt_ECF_Daruma(int iIndice, ref int iStatus);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int rConsultaStatusImpressoraStr_ECF_Daruma(int iIndice, StringBuilder StrStatus);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int rStatusImpressoraBinario_ECF_Daruma(StringBuilder Status);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int rRetornarInformacaoSeparador_ECF_Daruma(string strIndice, string strVSignificativo, StringBuilder strRetornar);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int rStatusUltimoCmdStr_ECF_Daruma(StringBuilder cErro, StringBuilder cAviso);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int rRetornarInformacao_ECF_Daruma(string strIndice, StringBuilder strRetornar);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int rRetornarNumeroSerieCodificado_ECF_Daruma(StringBuilder strSerialCriptografado);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int rVerificarNumeroSerieCodificado_ECF_Daruma(string strSerialCriptografado);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int rCarregarNumeroSerie_ECF_Daruma(StringBuilder strSerial);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int rRetornarDadosReducaoZ_ECF_Daruma(StringBuilder strDados);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int rRegistrarNumeroSerie_ECF_Daruma();
        [DllImport("DarumaFrameWork.dll")]
        public static extern int rRetornarGTCodificado_ECF_Daruma(StringBuilder strGTCodificado);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int rVerificarGTCodificado_ECF_Daruma(string strGTCodificado);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int ePAFValidarDados_ECF_Daruma(string strNomeArquivo, string strChave, string strNumSerieECF, string strGT);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int ePAFAtualizarGT_ECF_Daruma(string strNomeArquivo, string strChave, string strNumeroSerieECF, string strGT);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int ePAFCadastrar_ECF_Daruma(string strNomeArquivo, string strChave, string strNumeroSerieECF, string strGT);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int rLerArqRegistroPAF_ECF_Daruma(string strCaminho, string strChave, string strReturno);        
        [DllImport("DarumaFrameWork.dll")]
        public static extern int confModoPAF_ECF_Daruma(string strAtiva, string strChaveRSA, string strArquivo);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int eMemoriaFiscal_ECF_Daruma(string strInicial, string strFinal, Boolean boolCompleta, string strTip);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int rRSAChavePublica_ECF_Daruma(string strChavePrivada, StringBuilder strChavePublica, StringBuilder strExpoente);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int eAguardarCompactacao_ECF_Daruma();
        [DllImport("DarumaFrameWork.dll")]
        public static extern int eBuscarPortaVelocidade_ECF_Daruma();
        [DllImport("DarumaFrameWork.dll")]
        public static extern int eEnviarComando_ECF_Daruma(string cComando, int iTamanhoComando, int iType);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int eRetornarAviso_ECF_Daruma();
        [DllImport("DarumaFrameWork.dll")]
        public static extern int eRetornarErro_ECF_Daruma();
        [DllImport("DarumaFrameWork.dll")]
        public static extern int eRetornarPortasCOM_ECF_Daruma(StringBuilder strPortasCOM);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int eRSAAssinarArquivo_ECF_Daruma(string strArquivo, string strChave);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int eInterpretarErro_ECF_Daruma(int iErro, StringBuilder strDescErro);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int eInterpretarAviso_ECF_Daruma(int iAviso, StringBuilder strDescAviso);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int eInterpretastrRetorno_ECF_Daruma(int iRetorno, StringBuilder strDescRet);
        [DllImport("DarumaFramework.dll")]
        public static extern int eRetornarAvisoErroUltimoCMD_ECF_Daruma(StringBuilder strDescAviso, StringBuilder strDescErro);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int eAcionarGuilhotina_ECF_Daruma(string strTipoCorte);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int eCarregarBitmapPromocional_ECF_Daruma(string strPathLogo, string strIndiceLogo, string strOrientacao);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int regCCDDocOrigem_ECF_Daruma(string strParametro);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int regCCDFormaPgto_ECF_Daruma(string strParametro);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int regCCDLinhasTEF_ECF_Daruma(string strParametro);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int regCCDParcelas_ECF_Daruma(string strParametro);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int regCCDValor_ECF_Daruma(string strParametro);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int regCFFormaPgto_ECF_Daruma(string strParametro);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int regCFMensagemPromocional_ECF_Daruma(string strParametro);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int regCFQuantidade_ECF_Daruma(string strParametro);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int regCFTamanhoMinimoDescricao_ECF_Daruma(string strParametro);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int regCFTipoDescAcresc_ECF_Daruma(string strParametro);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int regCFUnidadeMedida_ECF_Daruma(string strParametro);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int regCFValorDescAcresc_ECF_Daruma(string strParametro);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int regCFCupomAdicional_ECF_Daruma(string strParametro);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int regCFCupomMania(string strParametro);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int regCFCupomAdicionalDllConfig_ECF_Daruma(string strParametro);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int regCFCupomAdicionalDllTitulo_ECF_Daruma(string strParametro);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int regChequeXLinha1_ECF_Daruma(string strParametro);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int regChequeXLinha2_ECF_Daruma(string strParametro);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int regChequeXLinha3_ECF_Daruma(string strParametro);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int regChequeYLinha1_ECF_Daruma(string strParametro);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int regChequeYLinha2_ECF_Daruma(string strParametro);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int regChequeYLinha3_ECF_Daruma(string strParametro);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int regCompatStatusFuncao_ECF_Daruma(string strParametro);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int regMaxFechamentoAutomatico_ECF_Daruma(string strParametro);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int regECFAguardarImpressao_ECF_Daruma(string strParametro);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int regECFArquivoLeituraX_ECF_Daruma(string strParametro);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int regECFAuditoria_ECF_Daruma(string strParametro);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int regECFCaracterSeparador_ECF_Daruma(string strParametro);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int regECFMaxFechamentoAutomatico_ECF_Daruma(string strParametro);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int regECFReceberAvisoEmArquivo_ECF_Daruma(string strParametro);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int regECFReceberErroEmArquivo_ECF_Daruma(string strParametro);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int regECFReceberInfoEstendida_ECF_Daruma(string strParametro);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int regECFReceberInfoEstendidaEmArquivo_ECF_Daruma(string strParametro);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int regAtocotepe_ECF_Daruma(string strParametro1, string strParametro2);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int regLogin_Daruma(string strPDV);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int regRetornaValorChave_DarumaFramework(string strProduto, string strChave, string strValor);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int regSintegra_ECF_Daruma(string strChave, string strParametro); 
        [DllImport("DarumaFrameWork.dll")]
        public static extern int regAtoCotepe_Daruma(string strChave, string strValor);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int eWsEnviarCupom_ECF_Daruma(string strCPF, string strNomeFantasia, string strIndiceSegmento, string strCCF, string strData, string strHora, string strValor, string strISS, string strICMS, string strReservado, int piSynAssync, ref int piRespostaWS);
        [DllImport("DarumaFrameWork.dll")]
        public static extern int eWsStatus_ECF_Daruma(ref int iRespostaWS);
        #endregion

        #endregion
    }
}