﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Exemplo_DFW
{
    public partial class formNFCE : Form
    {
        int iRet;
        string strMsg = "";
        public formNFCE()
        {
            InitializeComponent();
        }

        private void btnFechar_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void btnExecutar_Click(object sender, EventArgs e)
        {
            iRet = 0;
            strMsg = "";
            if (cbxMetodos.SelectedIndex == 0) // rAvisoErro_NFCe_Daruma(strCodigo, strMensagem)
            {
                StringBuilder strCodigo = new StringBuilder();
                StringBuilder strMensagem = new StringBuilder(1500);
                iRet = Declaracoes.rAvisoErro_NFCe_Daruma(strCodigo, strMensagem);
                if (iRet == 1)
                {
                    MessageBox.Show("Método executado com sucesso.", "Exemplo_DFW C# - NFCe", MessageBoxButtons.OK, MessageBoxIcon.Information);
                    tbxParam0.Enabled = true;
                    tbxParam1.Enabled = true;
                    tbxParam0.Text = strCodigo.ToString();
                    tbxParam1.Text = strMensagem.ToString();
                }

                else
                    MessageBox.Show("Ocorreu erro ao ler Aviso/Erro, erro retornado: [" + iRet.ToString() + "]", "Exemplo_DFW - NFCe", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
            else if (cbxMetodos.SelectedIndex == 1) // rCFVerificarStatus_NFCe_Daruma()
            {
                iRet = Declaracoes.rCFVerificarStatus_NFCe_Daruma();
                switch (iRet)
                {
                    case 0: strMsg = "[0] Nenhuma venda aberta"; break;
                    case 1: strMsg = "[1] Venda aberta sem itens vendidos"; break;
                    case 2: strMsg = "[2] Venda aberta e itens vendidos"; break;
                    case 3: strMsg = "[3] Venda totalizada"; break;
                    case 4: strMsg = "[4] Venda totalmente paga"; break;
                    case 5: strMsg = "[5] Venda encerrada"; break;
                    case 6: strMsg = "[6] Venda cancelada"; break;
                    default: strMsg = "Retornou: [" + iRet.ToString() + "] código de retorno não mapeado no exemplo"; break;
                }
                tbxParam0.Enabled = true;
                tbxParam0.Text = strMsg;

            }
            else if (cbxMetodos.SelectedIndex == 2) // rStatusWS_NFCe_Daruma()
            {
                iRet = Declaracoes.rStatusWS_NFCe_Daruma();
                strMsg = Declaracoes.TrataRetorno_NFCe(iRet);
                MessageBox.Show("Retorno do método: " + strMsg, "TrataRetorno_NFCe", MessageBoxButtons.OK, MessageBoxIcon.Information);
                if (iRet == 1)
                {
                    tbxParam0.Enabled = true;
                    tbxParam0.Text = "Retorno rStatusWS: " + strMsg;
                }

            }
            else if (cbxMetodos.SelectedIndex == 3) // rStatusImpressora_NFCe_Daruma()
            {
                iRet = Declaracoes.rStatusImpressora_NFCe_Daruma();
                strMsg = Declaracoes.TrataRetorno_NFCe(iRet);
                MessageBox.Show("Retorno do método: " + strMsg, "TrataRetorno_NFCe", MessageBoxButtons.OK, MessageBoxIcon.Information);
                if (iRet == 1)
                {
                    tbxParam0.Enabled = true;
                    tbxParam0.Text = "Retorno do rStatusImpressora_NFCe: " + strMsg;
                }
            }
            else if (cbxMetodos.SelectedIndex == 4) // rValidadeCertificado_NFCe_Daruma(StrDataVenc, StrDiasRestante)
            {
                StringBuilder strDtVenc = new StringBuilder();
                StringBuilder strDias = new StringBuilder();
                iRet = Declaracoes.rValidadeCertificado_NFCe_Daruma(strDtVenc, strDias);
                strMsg = Declaracoes.TrataRetorno_NFCe(iRet);
                MessageBox.Show("Retorno do método: " + strMsg, "TrataRetorno_NFCe", MessageBoxButtons.OK, MessageBoxIcon.Information);
                if (iRet == 1)
                {
                    tbxParam0.Enabled = true;
                    tbxParam1.Enabled = true;
                    tbxParam0.Text = strDtVenc.ToString();
                    tbxParam1.Text = strDias.ToString();
                }

            }
            else if (cbxMetodos.SelectedIndex == 5) // rInfoEstendida_NFCe_Daruma(strIndice, strRetorno)
            {
                StringBuilder strRetorno = new StringBuilder(1000);
                string strIndice = tbxParam0.Text;
                iRet = Declaracoes.rInfoEstendida_NFCe_Daruma(strIndice, strRetorno);
                strMsg = Declaracoes.TrataRetorno_NFCe(iRet);
                MessageBox.Show("Retorno do método: " + strMsg, "TrataRetorno_NFCe", MessageBoxButtons.OK, MessageBoxIcon.Information);
                if (iRet == 1)
                {
                    tbxParam1.Enabled = true;
                    tbxParam1.Text = strRetorno.ToString();
                }
            }
            else if (cbxMetodos.SelectedIndex == 6) // rLeituraX_NFCe_Daruma(strData, strSérie, strTipoRetorno, strRetorno)
            {
                string strData = tbxParam0.Text;
                string strSerie = tbxParam1.Text;
                string strTipoRet = tbxParam2.Text;
                StringBuilder strRetorno = new StringBuilder(5000);
                iRet = Declaracoes.rLeituraX_NFCe_Daruma(strData, strSerie, strTipoRet, strRetorno);
                strMsg = Declaracoes.TrataRetorno_NFCe(iRet);

            }
            else if (cbxMetodos.SelectedIndex == 7) // rRecuperarXML_NFCe_Daruma(strDataInicial, strDataFinal, strStatusNF, strPathXML)
            {
                string strDtInic = tbxParam0.Text;
                string strDtFinal = tbxParam1.Text;
                string strStatusNF = tbxParam2.Text;
                string strPath = tbxParam3.Text;
                iRet = Declaracoes.rRecuperarXML_NFCe_Daruma(strDtInic, strDtFinal, strStatusNF, strPath);
                strMsg = Declaracoes.TrataRetorno_NFCe(iRet);
                MessageBox.Show("Retorno do método: " + strMsg, "TrataRetorno_NFCe", MessageBoxButtons.OK, MessageBoxIcon.Information);

            }
            else if (cbxMetodos.SelectedIndex == 8) // rURLQrcode_NFCe_Daruma(strRetornoUrl)
            {
                StringBuilder strURL = new StringBuilder(1000);
                iRet = Declaracoes.rURLQrcode_NFCe_Daruma(strURL);
                strMsg = Declaracoes.TrataRetorno_NFCe(iRet);
                MessageBox.Show("Retorno do método: " + strMsg, "TrataRetorno_NFCe", MessageBoxButtons.OK, MessageBoxIcon.Information);
                if (iRet == 1)
                {
                    tbxParam0.Enabled = true;
                    tbxParam0.Text = strURL.ToString();
                }
            }

            else if (cbxMetodos.SelectedIndex == 9) //rNumDocsContingencia_NFCe_Daruma()
            {
                iRet = Declaracoes.rNumDocsContingencia_NFCe_Daruma();
                strMsg = "Foram encontrados [" + iRet.ToString() + "] arquivos .ctg no diretório";
                MessageBox.Show(strMsg, "TrataRetorno_NFCe", MessageBoxButtons.OK, MessageBoxIcon.Information);
                tbxParam0.Enabled = true;
                tbxParam0.Text = strMsg;
            }
            else if (cbxMetodos.SelectedIndex == 10) //rNumDocsContingenciaCanc_NFCe_Daruma()
            {
                iRet = Declaracoes.rNumDocsContingenciaCanc_NFCe_Daruma();
                strMsg = "Foram encontrados [" + iRet.ToString() + "] arquivos .ctgCanc (de cancelamento) no diretório";
                MessageBox.Show(strMsg, "TrataRetorno_NFCe", MessageBoxButtons.OK, MessageBoxIcon.Information);
                tbxParam0.Enabled = true;
                tbxParam0.Text = strMsg;
            }
            else if (cbxMetodos.SelectedIndex == 11) //rUltimaCtg_NFCe_Daruma(strUltimaCtg, strTipoContingencia)
            {
                StringBuilder strDadosCtg = new StringBuilder(3000);
                StringBuilder strTipoCtg = new StringBuilder();
                iRet = Declaracoes.rUltimaCtg_NFCe_Daruma(strDadosCtg, strTipoCtg);
                strMsg = Declaracoes.TrataRetorno_NFCe(iRet);
                MessageBox.Show("Retorno do método: " + strMsg, "TrataRetorno_NFCe", MessageBoxButtons.OK, MessageBoxIcon.Information);
                tbxParam0.Enabled = true;
                tbxParam0.Text = strDadosCtg.ToString();
                tbxParam1.Enabled = true;
                tbxParam1.Text = strTipoCtg.ToString();
            }
            else if (cbxMetodos.SelectedIndex == 12) //eEmiteOffline_NFCe_Daruma(strOpcao)
            {
                string strOpcao = tbxParam0.Text;
                iRet = Declaracoes.eEmiteOffline_NFCe_Daruma(strOpcao);
                strMsg = Declaracoes.TrataRetorno_NFCe(iRet);
                MessageBox.Show("Retorno do método: " + strMsg, "TrataRetorno_NFCe", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
            else if (cbxMetodos.SelectedIndex == 13) //eAjustarDataHora_NFCe_Daruma()
            {
                MessageBox.Show("Para realizar ajuste da Data Hora o aplicativo precisa ser executado com permissão de Administrador da máquina!", "eAjustarDataHora_NFCe - Importante!", MessageBoxButtons.OK, MessageBoxIcon.Information);
                iRet = Declaracoes.eAjustarDataHora_NFCe_Daruma();
                strMsg = Declaracoes.TrataRetorno_NFCe(iRet);
                MessageBox.Show("Retorno do método: " + strMsg, "TrataRetorno_NFCe", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
            else if (cbxMetodos.SelectedIndex == 14) //eAtualizarEnviarXML_NFCe_Daruma(strPathXML, strParametros, strEnviaXML);
            {
                string strCaminho = tbxParam0.Text;
                string strParametros = tbxParam1.Text;
                string strEnviar = tbxParam2.Text;
                iRet = Declaracoes.eAtualizarEnviarXML_NFCe_Daruma(strCaminho, strParametros, strEnviar);
                strMsg = Declaracoes.TrataRetorno_NFCe(iRet);
                MessageBox.Show("Retorno do método: " + strMsg, "TrataRetorno_NFCe", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
            else if (cbxMetodos.SelectedIndex == 15) //regAlterarValor_NFCe_Daruma(String StrTagNFCe, String StrValorTagNFCe);
            {
                string strTag = tbxParam0.Text;
                string strValor = tbxParam1.Text;
                iRet = Declaracoes.regAlterarValor_NFCe_Daruma(strTag, strValor);
                strMsg = Declaracoes.TrataRetorno_NFCe(iRet);
                MessageBox.Show("Retorno do método: " + strMsg, "TrataRetorno_NFCe", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
            else if (cbxMetodos.SelectedIndex == 16) //regRetornarValor_NFCe_Daruma(String StrTagNFCe, String StrValorTagNFCe);
            {
                string strTag = tbxParam0.Text;
                StringBuilder strValor= new StringBuilder(3000);
                iRet = Declaracoes.regRetornarValor_NFCe_Daruma(strTag, strValor);
                strMsg = Declaracoes.TrataRetorno_NFCe(iRet);
                if (iRet == 1)
                {
                    tbxParam1.Enabled = true;
                    tbxParam1.Text = strValor.ToString();
                }
                MessageBox.Show("Retorno do método: " + strMsg, "TrataRetorno_NFCe", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
        }

    

        private void cbxMetodos_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (cbxMetodos.SelectedIndex == 0) // rAvisoErro_NFCe_Daruma(strCodigo, strMensagem)
            {
                lblParam0.Text = "Codigo retornado:";
                lblParam1.Text = "Mensagem retornada:";
                lblParam2.Text = "-";
                lblParam3.Text = "-";
                tbxParam0.Enabled = false;
                tbxParam1.Enabled = false;
                tbxParam2.Enabled = false;
                tbxParam3.Enabled = false;
            }
            else if (cbxMetodos.SelectedIndex == 1) // rCFVerificarStatus_NFCe_Daruma()
            {
                lblParam0.Text = "Status venda NFC-e retornado:";
                lblParam1.Text = "-:";
                lblParam2.Text = "-";
                lblParam3.Text = "-";
                tbxParam0.Enabled = false;
                tbxParam1.Enabled = false;
                tbxParam2.Enabled = false;
                tbxParam3.Enabled = false;
            }
            else if (cbxMetodos.SelectedIndex == 2) // rStatusWS_NFCe_Daruma()
            {
                lblParam0.Text = "Status do WebService retornado:";
                lblParam1.Text = "-";
                lblParam2.Text = "-";
                lblParam3.Text = "-";
                tbxParam0.Enabled = false;
                tbxParam1.Enabled = false;
                tbxParam2.Enabled = false;
                tbxParam3.Enabled = false;
            }
            else if (cbxMetodos.SelectedIndex == 3) // rStatusImpressora_NFCe_Daruma()
            {
                lblParam0.Text = "Status da Impressora retonado:";
                lblParam1.Text = "-";
                lblParam2.Text = "-";
                lblParam3.Text = "-";
                tbxParam0.Enabled = false;
                tbxParam1.Enabled = false;
                tbxParam2.Enabled = false;
                tbxParam3.Enabled = false;
            }
            else if (cbxMetodos.SelectedIndex == 4) // rValidadeCertificado_NFCe_Daruma(StrDataVenc, StrDiasRestante)
            {
                lblParam0.Text = "Data de Venciamento do Certificado:";
                lblParam1.Text = "Número de dias restantes para o vencimento:";
                lblParam2.Text = "-";
                lblParam3.Text = "-";
                tbxParam0.Enabled = false;
                tbxParam1.Enabled = false;
                tbxParam2.Enabled = false;
                tbxParam3.Enabled = false;
            }
            else if (cbxMetodos.SelectedIndex == 5) // rInfoEstendida_NFCe_Daruma()
            {
                lblParam0.Text = "Indice da informação desejada (1 até 9 - depende do ultimo comando):";
                lblParam1.Text = "Informação retornada:";
                lblParam2.Text = "-";
                lblParam3.Text = "-";
                tbxParam0.Enabled = true;
                tbxParam1.Enabled = false;
                tbxParam2.Enabled = false;
                tbxParam3.Enabled = false;
            }
            else if (cbxMetodos.SelectedIndex == 6) // rLeituraX_NFCe_Daruma(strData, strSérie, strTipoRetorno, strRetorno)
            {
                lblParam0.Text = "Data:";
                lblParam1.Text = "Série:";
                lblParam2.Text = "Tipo de Retorno:";
                lblParam3.Text = "Retorno:";
                tbxParam0.Enabled = true;
                tbxParam1.Enabled = true;
                tbxParam2.Enabled = true;
                tbxParam3.Enabled = false;
            }
            else if (cbxMetodos.SelectedIndex == 7) // rRecuperarXML_NFCe_Daruma(strDataInicial, strDataFinal, strStatusNF, strPathXML)
            {
                lblParam0.Text = "Data Inicial:";
                lblParam1.Text = "Data Final:";
                lblParam2.Text = "Status das Notas:";
                lblParam3.Text = "Caminho para salvar os XMLs:";
                tbxParam0.Enabled = true;
                tbxParam1.Enabled = true;
                tbxParam2.Enabled = true;
                tbxParam3.Enabled = true;
            }
            else if (cbxMetodos.SelectedIndex == 8) // rURLQrcode_NFCe_Daruma(strRetornoUrl)
            {
                lblParam0.Text = "URL retornada:";
                lblParam1.Text = "-";
                lblParam2.Text = "-";
                lblParam3.Text = "-";
                tbxParam0.Enabled = false;
                tbxParam1.Enabled = false;
                tbxParam2.Enabled = false;
                tbxParam3.Enabled = false;
            }

            else if (cbxMetodos.SelectedIndex == 9) //rNumDocsContingencia_NFCe_Daruma()
            {
                lblParam0.Text = "Número de arquivos CTG existentes:";
                lblParam1.Text = "-";
                lblParam2.Text = "-";
                lblParam3.Text = "-";
                tbxParam0.Enabled = false;
                tbxParam1.Enabled = false;
                tbxParam2.Enabled = false;
                tbxParam3.Enabled = false;
            }
            else if (cbxMetodos.SelectedIndex == 10) //rNumDocsContingenciaCanc_NFCe_Daruma()
            {
                lblParam0.Text = "Número de arquivos CTG de Cancelamento existentes:";
                lblParam1.Text = "-";
                lblParam2.Text = "-";
                lblParam3.Text = "-";
                tbxParam0.Enabled = false;
                tbxParam1.Enabled = false;
                tbxParam2.Enabled = false;
                tbxParam3.Enabled = false;
            }
            else if (cbxMetodos.SelectedIndex == 11) //rUltimaCtg_NFCe_Daruma(strUltimaCtg, strTipoContingencia)
            {
                lblParam0.Text = "Dados do Último arquivo de Contingência:";
                lblParam1.Text = "Tipo de documento: C - Cancelamento, CI - Descarte ou NF:";
                lblParam2.Text = "-";
                lblParam3.Text = "-";
                tbxParam0.Enabled = false;
                tbxParam1.Enabled = false;
                tbxParam2.Enabled = false;
                tbxParam3.Enabled = false;
            }
            else if (cbxMetodos.SelectedIndex == 12) //eEmiteOffline_NFCe_Daruma(strOpcao)
            {
                lblParam0.Text = "Opção escolhida (0 - para Normal, 1 - força Offline): ";
                lblParam1.Text = "-";
                lblParam2.Text = "-";
                lblParam3.Text = "-";
                tbxParam0.Enabled = true;
                tbxParam1.Enabled = false;
                tbxParam2.Enabled = false;
                tbxParam3.Enabled = false;
            }
            else if (cbxMetodos.SelectedIndex == 13) //eAjustarDataHora_NFCe_Daruma()
            {
                lblParam0.Text = "-";
                lblParam1.Text = "-";
                lblParam2.Text = "-";
                lblParam3.Text = "-";
                tbxParam0.Enabled = false;
                tbxParam1.Enabled = false;
                tbxParam2.Enabled = false;
                tbxParam3.Enabled = false;
            }
            else if (cbxMetodos.SelectedIndex == 14) //eAtualizarEnviarXML_NFCe_Daruma(strPathXML, strParametros, strEnviaXML);
            {
                lblParam0.Text = "Caminho completo do arquivo XML:";
                lblParam1.Text = "Parametros:";
                lblParam2.Text = "Envia após alterar? 0 - Não Envia, 1 - Envia";
                lblParam3.Text = "-";
                tbxParam0.Enabled = true;
                tbxParam1.Enabled = true;
                tbxParam2.Enabled = true;
                tbxParam3.Enabled = false;
            }
            else if (cbxMetodos.SelectedIndex == 15) //regAlterarValor_NFCe_Daruma(StrTagNFCe, StrValorTagNFCe);
            {
                lblParam0.Text = "Configuração (tag):";
                lblParam1.Text = "Valor para a tag:";
                lblParam2.Text = "-";
                lblParam3.Text = "-";
                tbxParam0.Enabled = true;
                tbxParam1.Enabled = true;
                tbxParam2.Enabled = false;
                tbxParam3.Enabled = false;
            }
            else if (cbxMetodos.SelectedIndex == 16) //regRetornarValor_NFCe_Daruma(StrTagNFCe, StrValorTagNFCe);
            {
                lblParam0.Text = "Configuração (tag):";
                lblParam1.Text = "Valor retornado da tag:";
                lblParam2.Text = "-";
                lblParam3.Text = "-";
                tbxParam0.Enabled = true;
                tbxParam1.Enabled = false;
                tbxParam2.Enabled = false;
                tbxParam3.Enabled = false;
            }

        }

        private void btnLimpar_Click(object sender, EventArgs e)
        {
            tbxParam0.Text = "";
            tbxParam1.Text = "";
            tbxParam2.Text = "";
            tbxParam3.Text = "";
        }

        private void btnAbrir_Click(object sender, EventArgs e)
        {
            if (cbxAbrir.SelectedIndex==0) //aCFAbrir_NFCe_Daruma(9 parametros)
            {
                string strCpf = tbxCpf.Text;
                string strNome = tbxNome.Text;
                string strLogr = tbxLogradouro.Text;
                string strNum = tbxNum.Text;
                string strBairro = tbxBairro.Text;
                string strCmun = tbxCmun.Text;
                string strMun = tbxMunicipio.Text;
                string strUF = tbxUF.Text;
                string strCEP = tbxCep.Text;
                iRet = Declaracoes.aCFAbrir_NFCe_Daruma(strCpf, strNome, strLogr, strNum, strBairro, strCmun, strMun, strUF, strCEP);
                strMsg = Declaracoes.TrataRetorno_NFCe(iRet);
                MessageBox.Show("Retorno do método: " + strMsg, "TrataRetorno_NFCe", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
            else if (cbxAbrir.SelectedIndex == 1)  //aCFAbrirNumSerie_NFCe_Daruma(11 parametros)
            {
                string strNnf = tbxNnf.Text;
                string strSerie = tbxSerie.Text;
                string strCpf = tbxCpf.Text;
                string strNome = tbxNome.Text;
                string strLogr = tbxLogradouro.Text;
                string strNum = tbxNum.Text;
                string strBairro = tbxBairro.Text;
                string strCmun = tbxCmun.Text;
                string strMun = tbxMunicipio.Text;
                string strUF = tbxUF.Text;
                string strCEP = tbxCep.Text;
                iRet = Declaracoes.aCFAbrirNumSerie_NFCe_Daruma(strNnf, strSerie, strCpf, strNome, strLogr, strNum, strBairro, strCmun, strMun, strUF, strCEP);
                strMsg = Declaracoes.TrataRetorno_NFCe(iRet);
                MessageBox.Show("Retorno do método: " + strMsg, "TrataRetorno_NFCe", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
        }

        private void cbxAbrir_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (cbxAbrir.SelectedIndex == 0) //aCFAbrir_NFCe_Daruma(9 parametros)
            {
                tbxNnf.Enabled = false;
                tbxSerie.Enabled = false;
                tbxCpf.Enabled = true;
                tbxNome.Enabled = true;
                tbxLogradouro.Enabled = true;
                tbxNum.Enabled = true;
                tbxBairro.Enabled = true;
                tbxCmun.Enabled = true;
                tbxMunicipio.Enabled = true;
                tbxUF.Enabled = true;
                tbxCep.Enabled = true;

            }
            else if (cbxAbrir.SelectedIndex == 1)  //aCFAbrirNumSerie_NFCe_Daruma(11 parametros)
            {
                tbxNnf.Enabled = true;
                tbxSerie.Enabled = true;
                tbxCpf.Enabled = true;
                tbxNome.Enabled = true;
                tbxLogradouro.Enabled = true;
                tbxNum.Enabled = true;
                tbxBairro.Enabled = true;
                tbxCmun.Enabled = true;
                tbxMunicipio.Enabled = true;
                tbxUF.Enabled = true;
                tbxCep.Enabled = true;
            }
        }

        private void cbxConfigItens_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (cbxConfigItens.SelectedIndex == 0) //aCFConfImposto_NFCe_Daruma(strNomeImposto, strParametros)
            {
                lblParam00.Text = "-";
                lblParam01.Text = "-";
                lblParam02.Text = "-";
                lblParam03.Text = "-";
                lblParam04.Text = "-";
                lblParam05.Text = "-";
                lblParam06.Text = "-";
                lblParam07.Text = "-";
                lblParam08.Text = "-";
                lblParam09.Text = "-";
                lblParam10.Text = "-";
                lblParam11.Text = "-";
                lblParam12.Text = "Imposto que deseja configurar:";
                lblParam13.Text = "Parametros do Imposto:";
                tbxParametro00.Enabled = false;
                tbxParametro01.Enabled = false;
                tbxParametro02.Enabled = false;
                tbxParametro03.Enabled = false;
                tbxParametro04.Enabled = false;
                tbxParametro05.Enabled = false;
                tbxParametro06.Enabled = false;
                tbxParametro07.Enabled = false;
                tbxParametro08.Enabled = false;
                tbxParametro09.Enabled = false;
                tbxParametro10.Enabled = false;
                tbxParametro11.Enabled = false;
                tbxParametro12.Enabled = true;
                tbxParametro13.Enabled = true;
                tbxParametro12.Text = "ICMS00";
                tbxParametro13.Text = "0;00;3;;07,00;;;;";
            }
            else if (cbxConfigItens.SelectedIndex == 1)  //aCFConfLeiImposto_NFCe_Daruma(strNCM, strEx, strTipo, strNacionalFed, strImportadoFed, strEstadual, strMun)
            {
                lblParam00.Text = "NCM:";
                lblParam01.Text = "Ex:";
                lblParam02.Text = "Tipo:";
                lblParam03.Text = "Percentual Nacional Federal:";
                lblParam04.Text = "Percentual Importado Federal:";
                lblParam05.Text = "Percentual Estadual:";
                lblParam06.Text = "Percentual Municipal:";
                lblParam07.Text = "-";
                lblParam08.Text = "-";
                lblParam09.Text = "-";
                lblParam10.Text = "-";
                lblParam11.Text = "-";
                lblParam12.Text = "-";
                lblParam13.Text = "-";
                tbxParametro00.Enabled = true;
                tbxParametro01.Enabled = true;
                tbxParametro02.Enabled = true;
                tbxParametro03.Enabled = true;
                tbxParametro04.Enabled = true;
                tbxParametro05.Enabled = true;
                tbxParametro06.Enabled = true;
                tbxParametro07.Enabled = false;
                tbxParametro08.Enabled = false;
                tbxParametro09.Enabled = false;
                tbxParametro10.Enabled = false;
                tbxParametro11.Enabled = false;
                tbxParametro12.Enabled = false;
                tbxParametro13.Enabled = false;
            }
            if (cbxConfigItens.SelectedIndex == 2) //aCFConfCombustivel_NFCe_Daruma(14 parâmetros)
            {//strcProdANP,  strpMixGN,  strCODIF,  strqTemp,  strUFCons,  strqBCProd,  strvAliqProd,  strvCIDE,  strnBico,  strnBomba,  strnTanque,  strvEncInicial,  strvEncFinal,  strUsoFuturo
                lblParam00.Text = "Codigo de Produto ANP:";
                lblParam01.Text = "Percentual de Gás Natural:";
                lblParam02.Text = "Código de Autorização CODIF:";
                lblParam03.Text = "Quantidade Comb. faturada:";
                lblParam04.Text = "UF de Consumo:";
                lblParam05.Text = "Base Calc. da CIDE:";
                lblParam06.Text = "Valor (R$) Aliq. da CIDE:";
                lblParam07.Text = "Valor da CIDE:";
                lblParam08.Text = "Bico:";
                lblParam09.Text = "Bomba:";
                lblParam10.Text = "Tanque:";
                lblParam11.Text = "Encerrante Inicial:";
                lblParam12.Text = "Encerrante Final:";
                lblParam13.Text = "MetaParametro:";
                tbxParametro00.Enabled = true;
                tbxParametro01.Enabled = true;
                tbxParametro02.Enabled = true;
                tbxParametro03.Enabled = true;
                tbxParametro04.Enabled = true;
                tbxParametro05.Enabled = true;
                tbxParametro06.Enabled = true;
                tbxParametro07.Enabled = true;
                tbxParametro08.Enabled = true;
                tbxParametro09.Enabled = true;
                tbxParametro10.Enabled = true;
                tbxParametro11.Enabled = true;
                tbxParametro12.Enabled = true;
                tbxParametro13.Enabled = true;
            }
            else if (cbxConfigItens.SelectedIndex == 3)  //aCFConfRastro_NFCe_Daruma(strParametros)
            {
                lblParam00.Text = "-";
                lblParam01.Text = "-";
                lblParam02.Text = "-";
                lblParam03.Text = "-";
                lblParam04.Text = "-";
                lblParam05.Text = "-";
                lblParam06.Text = "-";
                lblParam07.Text = "-";
                lblParam08.Text = "-";
                lblParam09.Text = "-";
                lblParam10.Text = "-";
                lblParam11.Text = "-";
                lblParam12.Text = "-";
                lblParam13.Text = "Parametros do Grupo Rastro:";
                tbxParametro00.Enabled = false;
                tbxParametro01.Enabled = false;
                tbxParametro02.Enabled = false;
                tbxParametro03.Enabled = false;
                tbxParametro04.Enabled = false;
                tbxParametro05.Enabled = false;
                tbxParametro06.Enabled = false;
                tbxParametro07.Enabled = false;
                tbxParametro08.Enabled = false;
                tbxParametro09.Enabled = false;
                tbxParametro10.Enabled = false;
                tbxParametro11.Enabled = false;
                tbxParametro12.Enabled = false;
                tbxParametro13.Enabled = true;
            }
        }

        private void btnExecutarConfig_Click(object sender, EventArgs e)
        {
            if (cbxConfigItens.SelectedIndex == 0) //aCFConfImposto_NFCe_Daruma(strNomeImposto, strParametros)
            {
                string strImposto = tbxParametro12.Text;
                string strMetaparametro = tbxParametro13.Text;
                iRet = Declaracoes.aCFConfImposto_NFCe_Daruma(strImposto, strMetaparametro);
                strMsg = Declaracoes.TrataRetorno_NFCe(iRet);
                MessageBox.Show("Retorno do método: " + strMsg, "TrataRetorno_NFCe", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
            else if (cbxConfigItens.SelectedIndex == 1)  //aCFConfLeiImposto_NFCe_Daruma(strNCM, strEx, strTipo, strNacionalFed, strImportadoFed, strEstadual, strMun)
            {
                string strNCM = tbxParametro00.Text;
                string strEX = tbxParametro01.Text;
                string strTipo = tbxParametro02.Text;
                string strPnacional = tbxParametro03.Text;
                string strPimportado = tbxParametro04.Text;
                string strEstadual = tbxParametro05.Text;
                string strMunicipal = tbxParametro06.Text;
                iRet = Declaracoes.aCFConfLeiImposto_NFCe_Daruma(strNCM, strEX, strTipo, strPnacional, strPimportado, strEstadual, strMunicipal);
                strMsg = Declaracoes.TrataRetorno_NFCe(iRet);
                MessageBox.Show("Retorno do método: " + strMsg, "TrataRetorno_NFCe", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
            if (cbxConfigItens.SelectedIndex == 2) //aCFConfCombustivel_NFCe_Daruma(14 parâmetros)
            {//strcProdANP,  strpMixGN,  strCODIF,  strqTemp,  strUFCons,  strqBCProd,  strvAliqProd,  strvCIDE,  strnBico,  strnBomba,  strnTanque,  strvEncInicial,  strvEncFinal,  strUsoFuturo
                string strProdANP = tbxParametro00.Text;
                string strMixGN = tbxParametro01.Text;
                string strCodif = tbxParametro02.Text;
                string strQTemp = tbxParametro03.Text;
                string strUFcons = tbxParametro04.Text;
                string strBCprod = tbxParametro05.Text;
                string strAliqProd = tbxParametro06.Text;
                string strVlrCide = tbxParametro07.Text;
                string strIDbico = tbxParametro08.Text;
                string strIDbomba = tbxParametro09.Text;
                string strIDtanque = tbxParametro10.Text;
                string strEncIni = tbxParametro11.Text;
                string strEncFin = tbxParametro12.Text;
                string strMParam = tbxParametro13.Text;
                iRet = Declaracoes.aCFConfCombustivel_NFCe_Daruma(strProdANP, strMixGN, strCodif, strQTemp, strUFcons, strBCprod, strAliqProd, strVlrCide, strIDbico, strIDbomba, strIDtanque, strEncIni, strEncFin, strMParam);
                strMsg = Declaracoes.TrataRetorno_NFCe(iRet);
                MessageBox.Show("Retorno do método: " + strMsg, "TrataRetorno_NFCe", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
            else if (cbxConfigItens.SelectedIndex == 3)  //aCFConfRastro_NFCe_Daruma(strParametros)
            {
                string strParametros = tbxParametro13.Text;
                iRet = Declaracoes.aCFConfRastro_NFCe_Daruma(strParametros);
                strMsg = Declaracoes.TrataRetorno_NFCe(iRet);
                MessageBox.Show("Retorno do método: " + strMsg, "TrataRetorno_NFCe", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }

        }

        private void btnLimpaAbrir_Click(object sender, EventArgs e)
        {
            tbxNnf.Text = "";
            tbxSerie.Text = "";
            tbxCpf.Text = "";
            tbxNome.Text = "";
            tbxLogradouro.Text = "";
            tbxNum.Text = "";
            tbxBairro.Text = "";
            tbxCmun.Text = "";
            tbxMunicipio.Text = "";
            tbxUF.Text = "";
            tbxCep.Text = "";
        }

        private void btnLimpaCfg_Click(object sender, EventArgs e)
        {
            tbxParametro00.Text = "";
            tbxParametro01.Text = "";
            tbxParametro02.Text = "";
            tbxParametro03.Text = "";
            tbxParametro04.Text = "";
            tbxParametro05.Text = "";
            tbxParametro06.Text = "";
            tbxParametro07.Text = "";
            tbxParametro08.Text = "";
            tbxParametro09.Text = "";
            tbxParametro10.Text = "";
            tbxParametro11.Text = "";
            tbxParametro12.Text = "";
            tbxParametro13.Text = "";
        }

        private void cbxVender_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (cbxVender.SelectedIndex == 0)
            {
                tbxVAliq.Enabled = true;
                tbxVQtde.Enabled = true;
                tbxVVlrUnit.Enabled = true;
                cbxVTpDA.Enabled = true;
                tbxVVlrDA.Enabled = true;
                tbxVCodigo.Enabled = true;
                tbxVNCM.Enabled = true;
                tbxVCfop.Enabled = true;
                tbxVunMed.Enabled = true;
                tbxVDescricao.Enabled = true;
                tbxVMParam.Enabled = true;

                tbxVAliq.Text = "07,00";
                tbxVQtde.Text = "1,00";
                tbxVVlrUnit.Text = "0,10";
                cbxVTpDA.Text = "D$";
                tbxVVlrDA.Text = "0,00";
                tbxVCodigo.Text = "1234";
                tbxVNCM.Text = "18063210";
                tbxVCfop.Text = "5102";
                tbxVunMed.Text = "UND";
                tbxVDescricao.Text = "Item teste";
                tbxVMParam.Text = "CEST=1705700;cEAN=7896022204969;cEANTrib=7896022204969;";
            }
            else if (cbxVender.SelectedIndex == 1)
            {
                tbxVAliq.Enabled = false;
                tbxVQtde.Enabled = false;
                tbxVVlrUnit.Enabled = false;
                cbxVTpDA.Enabled = false;
                tbxVVlrDA.Enabled = false;
                tbxVCodigo.Enabled = false;
                tbxVNCM.Enabled = false;
                tbxVCfop.Enabled = false;
                tbxVunMed.Enabled = false;
                tbxVDescricao.Enabled = false;
                tbxVMParam.Enabled = true;
            }
        }

        private void btnVender_Click(object sender, EventArgs e)
        {
            if (cbxVender.SelectedIndex == 0)
            {
                string strAliq = tbxVAliq.Text;
                string strQtde = tbxVQtde.Text;
                string strVlrUnit= tbxVVlrUnit.Text;
                string strTpDA = cbxVTpDA.Text;
                string strVlrDA = tbxVVlrDA.Text;
                string strCodigo = tbxVCodigo.Text;
                string strNCM = tbxVNCM.Text;
                string strCfop = tbxVCfop.Text;
                string strUnMed = tbxVunMed.Text;
                string strDescricao = tbxVDescricao.Text;
                string strMetaParam = tbxVMParam.Text;
                iRet = Declaracoes.aCFVenderCompleto_NFCe_Daruma(strAliq, strQtde, strVlrUnit, strTpDA, strVlrDA, strCodigo, strNCM, strCfop, strUnMed, strDescricao, strMetaParam);
                strMsg = Declaracoes.TrataRetorno_NFCe(iRet);
                MessageBox.Show("Retorno do método: " + strMsg, "TrataRetorno_NFCe", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
            else if (cbxVender.SelectedIndex == 1)
            {
                string strMetaParam = tbxVMParam.Text;
                iRet = Declaracoes.aCFVenderXml_NFCe_Daruma(strMetaParam);
                strMsg = Declaracoes.TrataRetorno_NFCe(iRet);
                MessageBox.Show("Retorno do método: " + strMsg, "TrataRetorno_NFCe", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
        }

        private void cbxADCItens_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (cbxADCItens.SelectedIndex ==0) //aCFLancarAcrescimoItem_NFCe_Daruma(strNumItem, strTipoAcresc, strValorAcresc)
            {
                tbxNumItem.Enabled = true;
                lblTipoDA.Text = "Tipo do Acrescimo:";
                cbxITpDA.Enabled = true;
                lblValorQtd.Text = "Valor do Desconto/ Acrescimo:";
                tbxVlrDescAcre.Enabled = true;
            }
            else if (cbxADCItens.SelectedIndex == 1) //aCFLancarDescontoItem_NFCe_Daruma(strNumItem, strTipoDesc, strValorDesc)
            {
                tbxNumItem.Enabled = true;
                lblTipoDA.Text = "Tipo do Desconto:";
                cbxITpDA.Enabled = true;
                lblValorQtd.Text = "Valor do Desconto/ Acrescimo:";
                tbxVlrDescAcre.Enabled = true;
            }
            else if (cbxADCItens.SelectedIndex == 2) //aCFCancelarAcrescimoItem_NFCe_Daruma(strNumItem)
            {
                tbxNumItem.Enabled = true;
                lblTipoDA.Text = "-";
                cbxITpDA.Enabled = false;
                lblValorQtd.Text = "-";
                tbxVlrDescAcre.Enabled = false;
            }
            else if (cbxADCItens.SelectedIndex == 3) //aCFCancelarDescontoItem_NFCe_Daruma(strNumItem)
            {
                tbxNumItem.Enabled = true;
                lblTipoDA.Text = "-";
                cbxITpDA.Enabled = false;
                lblValorQtd.Text = "-";
                tbxVlrDescAcre.Enabled = false;
            }
            else if (cbxADCItens.SelectedIndex == 4) //aCFCancelarItemParcial_NFCe_Daruma(strNumItem, strQuant)
            {
                tbxNumItem.Enabled = true;
                cbxITpDA.Enabled = false;
                lblValorQtd.Text = "Quantidade a cancelar:";
                tbxVlrDescAcre.Enabled = true;
            }
            else if (cbxADCItens.SelectedIndex == 5) //aCFCancelarItem_NFCe_Daruma(strNumItem)
            {
                tbxNumItem.Enabled = true;
                lblTipoDA.Text = "-";
                cbxITpDA.Enabled = false;
                lblValorQtd.Text = "-";
                tbxVlrDescAcre.Enabled = false;
            }
        }

        private void btnExecutarDACItem_Click(object sender, EventArgs e)
        {
            if (cbxADCItens.SelectedIndex == 0) //aCFLancarAcrescimoItem_NFCe_Daruma(strNumItem, strTipoAcresc, strValorAcresc)
            {
                string strNumIt = tbxNumItem.Text;
                string strTipo = "";
                string strValor = tbxVlrDescAcre.Text;
                if (cbxITpDA.SelectedIndex ==0) // $
                {
                    strTipo = "A$";
                }
                else if (cbxITpDA.SelectedIndex ==1) //%
                {
                    strTipo = "A%";
                }
                iRet = Declaracoes.aCFLancarAcrescimoItem_NFCe_Daruma(strNumIt, strTipo, strValor);
                strMsg = Declaracoes.TrataRetorno_NFCe(iRet);
                MessageBox.Show("Retorno do método: " + strMsg, "TrataRetorno_NFCe", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
            else if (cbxADCItens.SelectedIndex == 1) //aCFLancarDescontoItem_NFCe_Daruma(strNumItem, strTipoDesc, strValorDesc)
            {
                string strNumIt = tbxNumItem.Text;
                string strTipo = "";
                string strValor = tbxVlrDescAcre.Text;
                if (cbxITpDA.SelectedIndex == 0) // $
                {
                    strTipo = "D$";
                }
                else if (cbxITpDA.SelectedIndex == 1) //%
                {
                    strTipo = "D%";
                }
                iRet = Declaracoes.aCFLancarDescontoItem_NFCe_Daruma(strNumIt, strTipo, strValor);
                strMsg = Declaracoes.TrataRetorno_NFCe(iRet);
                MessageBox.Show("Retorno do método: " + strMsg, "TrataRetorno_NFCe", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
            else if (cbxADCItens.SelectedIndex == 2) //aCFCancelarAcrescimoItem_NFCe_Daruma(strNumItem)
            {
                string strNumItem = tbxNumItem.Text;
                iRet = Declaracoes.aCFCancelarAcrescimoItem_NFCe_Daruma(strNumItem);
                strMsg = Declaracoes.TrataRetorno_NFCe(iRet);
                MessageBox.Show("Retorno do método: " + strMsg, "TrataRetorno_NFCe", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
            else if (cbxADCItens.SelectedIndex == 3) //aCFCancelarDescontoItem_NFCe_Daruma(strNumItem)
            {
                string strNumItem = tbxNumItem.Text;
                iRet = Declaracoes.aCFCancelarDescontoItem_NFCe_Daruma(strNumItem);
                strMsg = Declaracoes.TrataRetorno_NFCe(iRet);
                MessageBox.Show("Retorno do método: " + strMsg, "TrataRetorno_NFCe", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
            else if (cbxADCItens.SelectedIndex == 4) //aCFCancelarItemParcial_NFCe_Daruma(strNumItem, strQuant)
            {
                string strNumItem = tbxNumItem.Text;
                string strQtdCanc = tbxVlrDescAcre.Text;
                iRet = Declaracoes.aCFCancelarItemParcial_NFCe_Daruma(strNumItem, strQtdCanc);
                strMsg = Declaracoes.TrataRetorno_NFCe(iRet);
                MessageBox.Show("Retorno do método: " + strMsg, "TrataRetorno_NFCe", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
            else if (cbxADCItens.SelectedIndex == 5) //aCFCancelarItem_NFCe_Daruma(strNumItem)
            {
                string strNumItem = tbxNumItem.Text;
                iRet = Declaracoes.aCFCancelarItem_NFCe_Daruma(strNumItem);
                strMsg = Declaracoes.TrataRetorno_NFCe(iRet);
                MessageBox.Show("Retorno do método: " + strMsg, "TrataRetorno_NFCe", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
        }

        private void btnTotaliza_Click(object sender, EventArgs e)
        {
            string strTipoDA = "";
            if (cbxTotTpDA.SelectedIndex == 0) //D$
                strTipoDA = "D$";
            else if (cbxTotTpDA.SelectedIndex == 1) //D%
                strTipoDA = "D%";
            else if (cbxTotTpDA.SelectedIndex == 2) //A$
                strTipoDA = "A$";
            else if (cbxTotTpDA.SelectedIndex == 3) //A%
                strTipoDA = "A%";
            string strValorDA = tbxTotVlrDA.Text;
            iRet = Declaracoes.aCFTotalizar_NFCe_Daruma(strTipoDA, strValorDA);
            strMsg = Declaracoes.TrataRetorno_NFCe(iRet);
            MessageBox.Show("Retorno do método: " + strMsg, "TrataRetorno_NFCe", MessageBoxButtons.OK, MessageBoxIcon.Information);
        }

        private void cbxIdentificar_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (cbxIdentificar.SelectedIndex == 0) //aCFIdentificarConsumidor_NFCe
            {
                lblLogEnd.Text = "Logradouro:";
                tbxIdCpfCnpj.Enabled = true;
                tbxIdNome.Enabled = true;
                tbxIdLogEnd.Enabled = true;
                tbxIdNum.Enabled = true;
                tbxIdBairro.Enabled = true;
                tbxIdCodMun.Enabled = true;
                tbxIdMunicipio.Enabled = true;
                tbxIdUF.Enabled = true;
                tbxIdCEP.Enabled = true;
                tbxIdEmail.Enabled = true;
                tbxIdIE.Enabled = false;
                
            }
            else if (cbxIdentificar.SelectedIndex == 1) //aCFIdentificarTransportadora_NFCe
            {
                lblLogEnd.Text = "Endereço:";
                tbxIdIE.Enabled = true;
                tbxIdNum.Enabled = false;
                tbxIdBairro.Enabled = false;
                tbxIdCodMun.Enabled = false;
                tbxIdCEP.Enabled = false;
                tbxIdEmail.Enabled = false;
                tbxIdCpfCnpj.Enabled = true;
                tbxIdNome.Enabled = true;
                tbxIdLogEnd.Enabled = true;
                tbxIdMunicipio.Enabled = true;
                tbxIdUF.Enabled = true;
            }

        }

        private void btnIdentificar_Click(object sender, EventArgs e)
        {
            if (cbxIdentificar.SelectedIndex == 0) //aCFIdentificarConsumidor_NFCe(strCPF, strNome, strLgr, strNro, strBairro, strcMun, strMunicipio, strUF, strCEP, strEmail)
            {
                string strCPF = tbxIdCpfCnpj.Text;
                string strNome = tbxIdNome.Text;
                string strLgr = tbxIdLogEnd.Text;
                string strNro = tbxIdNum.Text;
                string strBairro = tbxIdBairro.Text;
                string strCmun = tbxIdCodMun.Text;
                string strMun = tbxIdMunicipio.Text;
                string strUF = tbxIdUF.Text;
                string strCep = tbxIdCEP.Text;
                string strEmail = tbxIdEmail.Text;
                iRet = Declaracoes.aCFIdentificarConsumidor_NFCe_Daruma(strCPF, strNome, strLgr, strNro, strBairro, strCmun, strMun, strUF, strCep, strEmail);
                strMsg = Declaracoes.TrataRetorno_NFCe(iRet);
                MessageBox.Show("Retorno do método: " + strMsg, "TrataRetorno_NFCe", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
            else if (cbxIdentificar.SelectedIndex == 1) //aCFIdentificarTransportadora_NFCe
            {
                string strCpfCnpj = tbxIdCpfCnpj.Text;
                string strNome = tbxIdNome.Text;
                string strIE = tbxIdIE.Text;
                string strEnder = tbxIdLogEnd.Text;
                string strMun = tbxIdMunicipio.Text;
                string strUF = tbxIdUF.Text;
                iRet = Declaracoes.aCFIdentificarTransportadora_NFCe_Daruma(strCpfCnpj, strNome, strIE, strEnder, strMun, strUF);
                strMsg = Declaracoes.TrataRetorno_NFCe(iRet);
                MessageBox.Show("Retorno do método: " + strMsg, "TrataRetorno_NFCe", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
        }

        private void cbxPagamento_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (cbxPagamento.SelectedIndex == 0) //aCFIdentificarCartao_NFCe(strCNPJ, strBandeira, strAutorizacao)
            {
                lblPgParam0.Text = "CNPJ:";
                lblPgParam1.Text = "Nome Bandeira:";
                lblPgParam2.Text = "Núm. Autorização:";
                lblPgParam3.Text = "-";
                lblPgParam4.Text = "-";
                lblPgParam5.Text = "-";
                lblPgParam6.Text = "-";
                tbxPgParam0.Enabled = true;
                tbxPgParam1.Enabled = true;
                tbxPgParam2.Enabled = true;
                tbxPgParam3.Enabled = false;
                tbxPgParam4.Enabled = false;
                tbxPgParam5.Enabled = false;
                tbxPgParam6.Enabled = false;
            }
            else if (cbxPagamento.SelectedIndex == 1) //aCFEfetuarPagamento_NFCe(strFormaPgto, strValor)
            {
                lblPgParam0.Text = "Forma de Pagamento:";
                lblPgParam1.Text = "Valor do Pagamento:";
                lblPgParam2.Text = "-";
                lblPgParam3.Text = "-";
                lblPgParam4.Text = "-";
                lblPgParam5.Text = "-";
                lblPgParam6.Text = "-";
                tbxPgParam0.Enabled = true;
                tbxPgParam1.Enabled = true;
                tbxPgParam2.Enabled = false;
                tbxPgParam3.Enabled = false;
                tbxPgParam4.Enabled = false;
                tbxPgParam5.Enabled = false;
                tbxPgParam6.Enabled = false;
                tbxPgParam0.Text = "Dinheiro";
                tbxPgParam1.Text = "0,00";
            }
            else if (cbxPagamento.SelectedIndex == 2) //aCFEfetuarPagamentoCartao_NFCe(strTpCartao, strVlrPgto, strTpInteg, strCNPJCred, strCodBand, strAutorizacao, strUsoFuturo)
            {
                lblPgParam0.Text = "Tipo do Cartão:";
                lblPgParam1.Text = "Valor do Pagamento:";
                lblPgParam2.Text = "Tipo de Integração:";
                lblPgParam3.Text = "CNPJ Credenciadora:";
                lblPgParam4.Text = "Código da Bandeira do Cartão:";
                lblPgParam5.Text = "Número da Autorização:";
                lblPgParam6.Text = "Uso Futuro:";
                tbxPgParam0.Enabled = true;
                tbxPgParam1.Enabled = true;
                tbxPgParam2.Enabled = true;
                tbxPgParam3.Enabled = true;
                tbxPgParam4.Enabled = true;
                tbxPgParam5.Enabled = true;
                tbxPgParam6.Enabled = true;
            }
            else if (cbxPagamento.SelectedIndex == 3) //aCFEstornarPagamento_NFCe(strNFormaPagtoEstornado, strFormaPagtoEfetivado, strValor)
            {
                lblPgParam0.Text = "Forma de Pagamento Estornar:";
                lblPgParam1.Text = "Nova forma de Pagamento:";
                lblPgParam2.Text = "Valor do Pagamento:";
                lblPgParam3.Text = "-";
                lblPgParam4.Text = "-";
                lblPgParam5.Text = "-";
                lblPgParam6.Text = "-";
                tbxPgParam0.Enabled = true;
                tbxPgParam1.Enabled = true;
                tbxPgParam2.Enabled = true;
                tbxPgParam3.Enabled = false;
                tbxPgParam4.Enabled = false;
                tbxPgParam5.Enabled = false;
                tbxPgParam6.Enabled = false;
            }
        }

        private void btnPagar_Click(object sender, EventArgs e)
        {
            if (cbxPagamento.SelectedIndex == 0) //aCFIdentificarCartao_NFCe(strCNPJ, strBandeira, strAutorizacao)
            {
                string strCNPJ = tbxPgParam0.Text;
                string strBand = tbxPgParam1.Text;
                string strNAutoriza = tbxPgParam3.Text;
                iRet = Declaracoes.aCFIdentificarCartao_NFCe_Daruma(strCNPJ, strBand, strNAutoriza);
                strMsg = Declaracoes.TrataRetorno_NFCe(iRet);
                MessageBox.Show("Retorno do método: " + strMsg, "TrataRetorno_NFCe", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
            else if (cbxPagamento.SelectedIndex == 1) //aCFEfetuarPagamento_NFCe(strFormaPgto, strValor)
            {
                string strFormaPag = tbxPgParam0.Text;
                string strValorPag = tbxPgParam1.Text;
                iRet = Declaracoes.aCFEfetuarPagamento_NFCe_Daruma(strFormaPag, strValorPag);
                strMsg = Declaracoes.TrataRetorno_NFCe(iRet);
                MessageBox.Show("Retorno do método: " + strMsg, "TrataRetorno_NFCe", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
            else if (cbxPagamento.SelectedIndex == 2) //aCFEfetuarPagamentoCartao_NFCe(strTpCartao, strVlrPgto, strTpInteg, strCNPJCred, strCodBand, strAutorizacao, strUsoFuturo)
            {
                string strTpCartao = tbxPgParam0.Text;
                string strVlrPag = tbxPgParam1.Text;
                string strTpIntegra = tbxPgParam2.Text;
                string strCNPJCred = tbxPgParam3.Text;
                string strCodBand = tbxPgParam4.Text;
                string strNumAut = tbxPgParam5.Text;
                string strUsoFut = tbxPgParam6.Text;
                iRet = Declaracoes.aCFEfetuarPagamentoCartao_NFCe_Daruma(strTpCartao, strVlrPag, strTpIntegra, strCNPJCred, strCodBand, strNumAut, strUsoFut);
                strMsg = Declaracoes.TrataRetorno_NFCe(iRet);
                MessageBox.Show("Retorno do método: " + strMsg, "TrataRetorno_NFCe", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
            else if (cbxPagamento.SelectedIndex == 3) //aCFEstornarPagamento_NFCe(strNFormaPagtoEstornado, strFormaPagtoEfetivado, strValor)
            {
                string strPgtoEstorno = tbxPgParam0.Text;
                string strNovoPgto = tbxPgParam1.Text;
                string strVlrPgto = tbxPgParam2.Text;
                iRet = Declaracoes.aCFEstornarPagamento_NFCe_Daruma(strPgtoEstorno, strNovoPgto, strVlrPgto);
                strMsg = Declaracoes.TrataRetorno_NFCe(iRet);
                MessageBox.Show("Retorno do método: " + strMsg, "TrataRetorno_NFCe", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
        }

        private void btnLimparPg_Click(object sender, EventArgs e)
        {
            tbxPgParam0.Text = "";
            tbxPgParam1.Text = "";
            tbxPgParam2.Text = "";
            tbxPgParam3.Text = "";
            tbxPgParam4.Text = "";
            tbxPgParam5.Text = "";
            tbxPgParam6.Text = "";
        }

        private void cbxEncerrar_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (cbxEncerrar.SelectedIndex ==0) //aCFMsgPromocional_NFCe_Daruma(strMsgPromocional, strTextoLivre)
            {
                lblEncParam0.Text = "Mensagem Promocional:";
                lblEncParam1.Text = "Texto Livre:";
                lblEncParam2.Text = "-";
                tbxEncParam0.Enabled = true;
                tbxEncParam1.Enabled = true;
                tbxEncParam2.Enabled = false;                
            }
            else if (cbxEncerrar.SelectedIndex == 1) //tCFEncerrar_NFCe_Daruma(strMsgPromocional)
            {
                lblEncParam0.Text = "Mensagem Promocional:";
                lblEncParam1.Text = "-";
                lblEncParam2.Text = "-";
                tbxEncParam0.Enabled = true;
                tbxEncParam1.Enabled = false;
                tbxEncParam2.Enabled = false;
                tbxEncParam0.Text = "Obrigada e volte sempre.";
            }
            else if (cbxEncerrar.SelectedIndex == 2) //tCFEncerrarConfigMsg_NFCe_Daruma(strMsgPromo, strMsgFisco, strUsoFuturo)
            {
                lblEncParam0.Text = "Mensagem Promocional:";
                lblEncParam1.Text = "Mensagem Fisco:";
                lblEncParam2.Text = "Uso Futuro:";
                tbxEncParam0.Enabled = true;
                tbxEncParam1.Enabled = true;
                tbxEncParam2.Enabled = true;
            }
        }

        private void btnEncerrar_Click(object sender, EventArgs e)
        {
            if (cbxEncerrar.SelectedIndex == 0) //aCFMsgPromocional_NFCe_Daruma(strMsgPromocional, strTextoLivre)
            {
                string strMsgPromo = tbxEncParam0.Text;
                string strTxtLivre = tbxEncParam1.Text;
                iRet = Declaracoes.aCFMsgPromocional_NFCe_Daruma(strMsgPromo, strTxtLivre);
                strMsg = Declaracoes.TrataRetorno_NFCe(iRet);
                MessageBox.Show("Retorno do método: " + strMsg, "TrataRetorno_NFCe", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
            else if (cbxEncerrar.SelectedIndex == 1) //tCFEncerrar_NFCe_Daruma(strMsgPromocional)
            {
                string strMsgPromo = tbxEncParam0.Text;
                iRet = Declaracoes.tCFEncerrar_NFCe_Daruma(strMsgPromo);
                strMsg = Declaracoes.TrataRetorno_NFCe(iRet);
                MessageBox.Show("Retorno do método: " + strMsg, "TrataRetorno_NFCe", MessageBoxButtons.OK, MessageBoxIcon.Information);
                cbxMetodos.SelectedIndex = 0;
                btnExecutar.PerformClick();
            }
            else if (cbxEncerrar.SelectedIndex == 2) //tCFEncerrarConfigMsg_NFCe_Daruma(strMsgPromo, strMsgFisco, strUsoFuturo)
            {
                string strMsgPromo = tbxEncParam0.Text;
                string strMsgFisco = tbxEncParam1.Text;
                string strMetaparam = tbxEncParam2.Text;
                iRet = Declaracoes.tCFEncerrarConfigMsg_NFCe_Daruma(strMsgPromo, strMsgFisco, strMetaparam);
                strMsg = Declaracoes.TrataRetorno_NFCe(iRet);
                MessageBox.Show("Retorno do método: " + strMsg, "TrataRetorno_NFCe", MessageBoxButtons.OK, MessageBoxIcon.Information);
                cbxMetodos.SelectedIndex = 0;
                btnExecutar.PerformClick();
            }
        }

        private void cbxCancelar_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (cbxCancelar.SelectedIndex ==0)  //tCFCancelar_NFCe_Daruma(strNNF, strNSerie, strChAcesso, strProtAutorizacao, strJustificativa)
            {
                lblCancParam0.Text = "Número da Nota:";
                lblCancParam1.Text = "Série da Nota:";
                lblCancParam2.Text = "Chave de acesso:";
                tbxCancParam0.Enabled = true;
                tbxCancParam1.Enabled = true;
                tbxCancParam2.Enabled = true;
                tbxCancProtAut.Enabled = true;
                tbxCancJustifica.Enabled = true;
                tbxCancMetaparam.Enabled = false;
            }
            else if (cbxCancelar.SelectedIndex == 1)  //tCFCancelarParametrizado_NFCe_Daruma(strNNF, strNSerie, strChAcesso, strProtAutorizacao, strJustificativa, strParametros)
            {
                lblCancParam0.Text = "Número da Nota:";
                lblCancParam1.Text = "Série da Nota:";
                lblCancParam2.Text = "Chave de acesso:";
                tbxCancParam0.Enabled = true;
                tbxCancParam1.Enabled = true;
                tbxCancParam2.Enabled = true;
                tbxCancProtAut.Enabled = true;
                tbxCancJustifica.Enabled = true;
                tbxCancMetaparam.Enabled = true;
            }
            else if (cbxCancelar.SelectedIndex == 2)  //tCFCancelarOffline_NFCe_Daruma(strNNF, strNSerie, strChAcesso, strJustificativa)
            {
                lblCancParam0.Text = "Número da Nota:";
                lblCancParam1.Text = "Série da Nota:";
                lblCancParam2.Text = "Chave de acesso:";
                tbxCancParam0.Enabled = true;
                tbxCancParam1.Enabled = true;
                tbxCancParam2.Enabled = true;
                tbxCancProtAut.Enabled = false;
                tbxCancJustifica.Enabled = true;
                tbxCancMetaparam.Enabled = false;
            }
            else if (cbxCancelar.SelectedIndex == 3)  //tCFInutilizar_NFCe_Daruma(strnNFInic, strnNFFim, strNSerie, strJustificativa)
            {
                lblCancParam0.Text = "Número da Nota Inicial:";
                lblCancParam1.Text = "Número da Nota Final:";
                lblCancParam2.Text = "Série:";
                tbxCancParam0.Enabled = true;
                tbxCancParam1.Enabled = true;
                tbxCancParam2.Enabled = true;
                tbxCancProtAut.Enabled = false;
                tbxCancJustifica.Enabled = true;
                tbxCancMetaparam.Enabled = false;
            }
            else if (cbxCancelar.SelectedIndex == 4)  //tDescartarNota_NFCe_Daruma(strNF, strSerie, strOpcao)
            {
                lblCancParam0.Text = "Número da Nota:";
                lblCancParam1.Text = "Série da Nota:";
                lblCancParam2.Text = "Opção:";
                tbxCancParam0.Enabled = true;
                tbxCancParam1.Enabled = true;
                tbxCancParam2.Enabled = true;
                tbxCancProtAut.Enabled = false;
                tbxCancJustifica.Enabled = false;
                tbxCancMetaparam.Enabled = false;
            }
        }

        private void btnExecutaCancelar_Click(object sender, EventArgs e)
        {
            if (cbxCancelar.SelectedIndex == 0)  //tCFCancelar_NFCe_Daruma(strNNF, strNSerie, strChAcesso, strProtAutorizacao, strJustificativa)
            {
                string strNnf = tbxCancParam0.Text;
                string strSerie = tbxCancParam1.Text;
                string strChAcesso = tbxCancParam2.Text;
                string strProtocolo = tbxCancProtAut.Text;
                string strJust = tbxCancJustifica.Text;
                iRet = Declaracoes.tCFCancelar_NFCe_Daruma(strNnf, strSerie, strChAcesso, strProtocolo, strJust);
                strMsg = Declaracoes.TrataRetorno_NFCe(iRet);
                MessageBox.Show("Retorno do método: " + strMsg, "TrataRetorno_NFCe", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
            else if (cbxCancelar.SelectedIndex == 1)  //tCFCancelarParametrizado_NFCe_Daruma(strNNF, strNSerie, strChAcesso, strProtAutorizacao, strJustificativa, strParametros)
            {
                string strNnf = tbxCancParam0.Text;
                string strSerie = tbxCancParam1.Text;
                string strChAcesso = tbxCancParam2.Text;
                string strProtocolo = tbxCancProtAut.Text;
                string strJust = tbxCancJustifica.Text;
                string strMetaParam = tbxCancMetaparam.Text;
                iRet = Declaracoes.tCFCancelarParametrizado_NFCe_Daruma(strNnf, strSerie, strChAcesso, strProtocolo, strJust, strMetaParam);
                strMsg = Declaracoes.TrataRetorno_NFCe(iRet);
                MessageBox.Show("Retorno do método: " + strMsg, "TrataRetorno_NFCe", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
            else if (cbxCancelar.SelectedIndex == 2)  //tCFCancelarOffline_NFCe_Daruma(strNNF, strNSerie, strChAcesso, strJustificativa)
            {
                string strNnf = tbxCancParam0.Text;
                string strSerie = tbxCancParam1.Text;
                string strChAcesso = tbxCancParam2.Text;
                string strJust = tbxCancJustifica.Text;
                iRet = Declaracoes.tCFCancelarOffline_NFCe_Daruma(strNnf, strSerie, strChAcesso, strJust);
                strMsg = Declaracoes.TrataRetorno_NFCe(iRet);
                MessageBox.Show("Retorno do método: " + strMsg, "TrataRetorno_NFCe", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
            else if (cbxCancelar.SelectedIndex == 3)  //tCFInutilizar_NFCe_Daruma(strnNFInic, strnNFFim, strNSerie, strJustificativa)
            {
                string strNumInic = tbxCancParam0.Text;
                string strNumFim = tbxCancParam1.Text;
                string strSerie = tbxCancParam2.Text;
                string strJust = tbxCancJustifica.Text;
                iRet = Declaracoes.tCFInutilizar_NFCe_Daruma(strNumInic, strNumFim, strSerie, strJust);
                strMsg = Declaracoes.TrataRetorno_NFCe(iRet);
                MessageBox.Show("Retorno do método: " + strMsg, "TrataRetorno_NFCe", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
            else if (cbxCancelar.SelectedIndex == 4)  //tDescartarNota_NFCe_Daruma(strNF, strSerie, strOpcao)
            {
                string strNnf = tbxCancParam0.Text;
                string strSerie = tbxCancParam1.Text;
                string strOpcao = tbxCancParam2.Text;
                iRet = Declaracoes.tDescartarNota_NFCe_Daruma(strNnf, strSerie, strOpcao);
                strMsg = Declaracoes.TrataRetorno_NFCe(iRet);
                MessageBox.Show("Retorno do método: " + strMsg, "TrataRetorno_NFCe", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
        }

        private void btnReimprime_Click(object sender, EventArgs e)
        {
            string strNnf = tbxReImpNnf.Text;
            string strSerie = tbxReImpSerie.Text;
            string strChave = tbxReImpChave.Text;
            iRet = Declaracoes.iCFReImprimir_NFCe_Daruma(strNnf, strSerie, strChave);
            strMsg = Declaracoes.TrataRetorno_NFCe(iRet);
            MessageBox.Show("Retorno do método: " + strMsg, "TrataRetorno_NFCe", MessageBoxButtons.OK, MessageBoxIcon.Information);
        }

        private void cbxImprimir_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (cbxImprimir.SelectedIndex == 0)
            {
                tbxImpPathEnvio.Enabled = true;
                tbxImpPathRetorno.Enabled = true;
                tbxImpLink.Enabled = true;
                tbxImpColunas.Enabled = true;
                cbxImpTipoNF.Enabled = true;
                tbxImpMetaparam.Enabled = false;
            }
            else if (cbxImprimir.SelectedIndex == 1)
            {
                tbxImpPathEnvio.Enabled = true;
                tbxImpPathRetorno.Enabled = true;
                tbxImpLink.Enabled = true;
                tbxImpColunas.Enabled = true;
                cbxImpTipoNF.Enabled = true;
                tbxImpMetaparam.Enabled = true;
            }
                
        }

        private void btnImprimir_Click(object sender, EventArgs e)
        {
            if (cbxImprimir.SelectedIndex == 0) //iImprimir_NFCe
            {
                string strPathEnvio = tbxImpPathEnvio.Text;
                string strPathRetorno = tbxImpPathRetorno.Text;
                string strLink = tbxImpLink.Text;
                int iNcolunas = Convert.ToInt32(tbxImpColunas.Text);
                int iTipoNF = (cbxImpTipoNF.SelectedIndex)+1;
                iRet = Declaracoes.iCFImprimir_NFCe_Daruma(strPathEnvio, strPathRetorno, strLink, iNcolunas, iTipoNF);
                strMsg = Declaracoes.TrataRetorno_NFCe(iRet);
                MessageBox.Show("Retorno do método: " + strMsg, "TrataRetorno_NFCe", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
            else if (cbxImprimir.SelectedIndex == 1) //iImprimirParametrizado_NFCe
            {
                string strPathEnvio = tbxImpPathEnvio.Text;
                string strPathRetorno = tbxImpPathRetorno.Text;
                string strLink = tbxImpLink.Text;
                string strMetaparam = tbxImpMetaparam.Text;
                int iNcolunas = Convert.ToInt32(tbxImpColunas.Text);
                int iTipoNF = (cbxImpTipoNF.SelectedIndex) + 1;
                iRet = Declaracoes.iCFImprimirParametrizado_NFCe_Daruma(strPathEnvio, strPathRetorno, strLink, iNcolunas, iTipoNF, strMetaparam);
                strMsg = Declaracoes.TrataRetorno_NFCe(iRet);
                MessageBox.Show("Retorno do método: " + strMsg, "TrataRetorno_NFCe", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
        }

        private void cbxEnviarCtgs_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (cbxEnviarCtgs.SelectedIndex == 0) //tEnviarContingenciaOffline_NFCe_Daruma(int iQtdDocsContingencia)
            {
                lblCtgParam0.Text = "Número de Arquivos a enviar:";
                lblCtgParam1.Text = "-";
                lblCtgParam2.Text = "-";
                lblCtgParam3.Text = "-";
                lblCtgParam4.Text = "-";
                lblCtgParam5.Text = "-";
                lblCtgParam6.Text = "-";
                tbxCtgParam0.Enabled = true;
                tbxCtgParam1.Enabled = false;
                tbxCtgParam2.Enabled = false;
                tbxCtgParam3.Enabled = false;
                tbxCtgParam4.Enabled = false;
                tbxCtgParam5.Enabled = false;
                tbxCtgParam6.Enabled = false;
            }
            else if (cbxEnviarCtgs.SelectedIndex == 1) //tEnviarContingenciaCancOffline_NFCe_Daruma(int iQtdDocsCancContingencia)
            {
                lblCtgParam0.Text = "Número de Arquivos a enviar:";
                lblCtgParam1.Text = "-";
                lblCtgParam2.Text = "-";
                lblCtgParam3.Text = "-";
                lblCtgParam4.Text = "-";
                lblCtgParam5.Text = "-";
                lblCtgParam6.Text = "-";
                tbxCtgParam0.Enabled = true;
                tbxCtgParam1.Enabled = false;
                tbxCtgParam2.Enabled = false;
                tbxCtgParam3.Enabled = false;
                tbxCtgParam4.Enabled = false;
                tbxCtgParam5.Enabled = false;
                tbxCtgParam6.Enabled = false;
            }
            else if (cbxEnviarCtgs.SelectedIndex == 2) //tEnvioUnitContingenciaOffline_NFCe_Daruma(strCNPJEmit, strSerie, strnNF, strProtocolo, strChaveAcesso, strSitCodigo)
            {
                lblCtgParam0.Text = "CNPJ Emitente:";
                lblCtgParam1.Text = "Série";
                lblCtgParam2.Text = "Número da Nota:";
                lblCtgParam3.Text = "Protocolo de Autorização:";
                lblCtgParam4.Text = "Chave de Acesso:";
                lblCtgParam5.Text = "SitCodigo:";
                lblCtgParam6.Text = "-";
                tbxCtgParam0.Enabled = false;
                tbxCtgParam1.Enabled = false;
                tbxCtgParam2.Enabled = false;
                tbxCtgParam3.Enabled = false;
                tbxCtgParam4.Enabled = false;
                tbxCtgParam5.Enabled = false;
                tbxCtgParam6.Enabled = false;
            }
            else if (cbxEnviarCtgs.SelectedIndex == 3) //tEnvioUnitContingenciaCancOffline_NFCe_DarumastrCNPJEmit, strSerie, strnNF, strProtocolo, strChaveAcesso, strSitCodigo){
            {
                lblCtgParam0.Text = "CNPJ Emitente:";
                lblCtgParam1.Text = "Série";
                lblCtgParam2.Text = "Número da Nota:";
                lblCtgParam3.Text = "Protocolo de Autorização:";
                lblCtgParam4.Text = "Chave de Acesso:";
                lblCtgParam5.Text = "SitCodigo:";
                lblCtgParam6.Text = "-";
                tbxCtgParam0.Enabled = false;
                tbxCtgParam1.Enabled = false;
                tbxCtgParam2.Enabled = false;
                tbxCtgParam3.Enabled = false;
                tbxCtgParam4.Enabled = false;
                tbxCtgParam5.Enabled = false;
                tbxCtgParam6.Enabled = false;
            }
            else if (cbxEnviarCtgs.SelectedIndex == 4) //tEnvioUnitCtg_NFCe_Daruma(strUltimaCtg, StrCNPJEmit, StrSerie, StrnNF, StrProtocolo, StrChaveAcesso, StrSitCodigo)
            {
                lblCtgParam0.Text = "Última Ctg:";
                lblCtgParam1.Text = "CNPJ Emitente";
                lblCtgParam2.Text = "Serie:";
                lblCtgParam3.Text = "Número da Nota:";
                lblCtgParam4.Text = "Protocolo de Autorização:";
                lblCtgParam5.Text = "Chave de Acesso:";
                lblCtgParam6.Text = "SitCodigo:";
                tbxCtgParam0.Enabled = true;
                tbxCtgParam1.Enabled = false;
                tbxCtgParam2.Enabled = false;
                tbxCtgParam3.Enabled = false;
                tbxCtgParam4.Enabled = false;
                tbxCtgParam5.Enabled = false;
                tbxCtgParam6.Enabled = false;
            }
        }

        private void btnExecutarEnvioCtg_Click(object sender, EventArgs e)
        {
            if (cbxEnviarCtgs.SelectedIndex == 0) //tEnviarContingenciaOffline_NFCe_Daruma(int iQtdDocsContingencia)
            {
                int iNumCtg = Convert.ToInt32(tbxCtgParam0.Text);
                iRet = Declaracoes.tEnviarContingenciaOffline_NFCe_Daruma(iNumCtg);
                strMsg = Declaracoes.TrataRetorno_NFCe(iRet);
                MessageBox.Show("Retorno do método: " + strMsg, "TrataRetorno_NFCe", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
            else if (cbxEnviarCtgs.SelectedIndex == 1) //tEnviarContingenciaCancOffline_NFCe_Daruma(int iQtdDocsCancContingencia)
            {
                int iNumCtg = Convert.ToInt32(tbxCtgParam0.Text);
                iRet = Declaracoes.tEnviarContingenciaCancOffline_NFCe_Daruma(iNumCtg);
                strMsg = Declaracoes.TrataRetorno_NFCe(iRet);
                MessageBox.Show("Retorno do método: " + strMsg, "TrataRetorno_NFCe", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
            else if (cbxEnviarCtgs.SelectedIndex == 2) //tEnvioUnitContingenciaOffline_NFCe_Daruma(strCNPJEmit, strSerie, strnNF, strProtocolo, strChaveAcesso, strSitCodigo)
            {
                StringBuilder strCnpjEmit = new StringBuilder();
                StringBuilder strSerie = new StringBuilder();
                StringBuilder strNnf = new StringBuilder();
                StringBuilder strProtocolo = new StringBuilder();
                StringBuilder strChAcesso = new StringBuilder();
                StringBuilder strSitCod = new StringBuilder();
                iRet = Declaracoes.tEnvioUnitContingenciaOffline_NFCe_Daruma(strCnpjEmit, strSerie, strNnf, strProtocolo, strChAcesso, strSitCod);
                strMsg = Declaracoes.TrataRetorno_NFCe(iRet);
                MessageBox.Show("Retorno do método: " + strMsg, "TrataRetorno_NFCe", MessageBoxButtons.OK, MessageBoxIcon.Information);
                tbxCtgParam0.Text = strCnpjEmit.ToString();
                tbxCtgParam1.Text = strSerie.ToString();
                tbxCtgParam2.Text = strNnf.ToString();
                tbxCtgParam3.Text = strProtocolo.ToString();
                tbxCtgParam4.Text = strChAcesso.ToString();
                tbxCtgParam5.Text = strSitCod.ToString();
            }
            else if (cbxEnviarCtgs.SelectedIndex == 3) //tEnvioUnitContingenciaCancOffline_NFCe_DarumastrCNPJEmit, strSerie, strnNF, strProtocolo, strChaveAcesso, strSitCodigo){
            {
                StringBuilder strCnpjEmit = new StringBuilder();
                StringBuilder strSerie = new StringBuilder();
                StringBuilder strNnf = new StringBuilder();
                StringBuilder strProtocolo = new StringBuilder();
                StringBuilder strChAcesso = new StringBuilder();
                StringBuilder strSitCod = new StringBuilder();
                iRet = Declaracoes.tEnvioUnitContingenciaCancOffline_NFCe_Daruma(strCnpjEmit, strSerie, strNnf, strProtocolo, strChAcesso, strSitCod);
                strMsg = Declaracoes.TrataRetorno_NFCe(iRet);
                MessageBox.Show("Retorno do método: " + strMsg, "TrataRetorno_NFCe", MessageBoxButtons.OK, MessageBoxIcon.Information);
                tbxCtgParam0.Text = strCnpjEmit.ToString();
                tbxCtgParam1.Text = strSerie.ToString();
                tbxCtgParam2.Text = strNnf.ToString();
                tbxCtgParam3.Text = strProtocolo.ToString();
                tbxCtgParam4.Text = strChAcesso.ToString();
                tbxCtgParam5.Text = strSitCod.ToString();
            }
            else if (cbxEnviarCtgs.SelectedIndex == 4) //tEnvioUnitCtg_NFCe_Daruma(strUltimaCtg, StrCNPJEmit, StrSerie, StrnNF, StrProtocolo, StrChaveAcesso, StrSitCodigo)
            {
                string strUltCtg = tbxCtgParam0.Text;
                StringBuilder strCnpjEmit = new StringBuilder();
                StringBuilder strSerie = new StringBuilder();
                StringBuilder strNnf = new StringBuilder();
                StringBuilder strProtocolo = new StringBuilder();
                StringBuilder strChAcesso = new StringBuilder();
                StringBuilder strSitCod = new StringBuilder();
                iRet = Declaracoes.tEnvioUnitCtg_NFCe_Daruma(strUltCtg, strCnpjEmit, strSerie, strNnf, strProtocolo, strChAcesso, strSitCod);
                strMsg = Declaracoes.TrataRetorno_NFCe(iRet);
                MessageBox.Show("Retorno do método: " + strMsg, "TrataRetorno_NFCe", MessageBoxButtons.OK, MessageBoxIcon.Information);
                tbxCtgParam1.Text = strCnpjEmit.ToString();
                tbxCtgParam2.Text = strSerie.ToString();
                tbxCtgParam3.Text = strNnf.ToString();
                tbxCtgParam4.Text = strProtocolo.ToString();
                tbxCtgParam5.Text = strChAcesso.ToString();
                tbxCtgParam6.Text = strSitCod.ToString();
            }
        }

        private void cbxRetornos_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (cbxRetornos.SelectedIndex == 0) //rRetornarInformacao_NFCe ( strTipoIntervalo,  strInic,  strFim,  strSerie,  strChaveAcesso,  strInfoConsulta, Builder StrResposta)
            {
                lblRetIni.Text = "Inicio:";
                lblRetResp.Text = "Resposta:";
                tbxRetTipo.Enabled = true;
                tbxRetFim.Enabled = true;
                tbxRetIni.Enabled = true;
                tbxRetSerie.Enabled = true;
                tbxRetChAcesso.Enabled = true;
                tbxRetInfo.Enabled = true;
                tbxRetResp.Enabled = false;
            }
            else if (cbxRetornos.SelectedIndex ==1) //rRetornarInformacaoArq_NFCe ( strTipoIntervalo,  strInic,  strFim,  strSerie,  strChaveAcesso,  strInfoConsulta,  strPathArqResposta)
            {
                lblRetIni.Text = "Inicio:";
                lblRetResp.Text = "Caminho do Arquivo para Resposta:";
                tbxRetTipo.Enabled = true;
                tbxRetFim.Enabled = true;
                tbxRetIni.Enabled = true;
                tbxRetSerie.Enabled = true;
                tbxRetChAcesso.Enabled = true;
                tbxRetInfo.Enabled = true;
                tbxRetResp.Enabled = true;
            }
            else if (cbxRetornos.SelectedIndex == 2) //rRetornarInformacaoContingencia_NFCe ( strChaveAcesso,  strNumNota,  strSerie,  strInfoConsulta, Builder strRetorno)
            {
                lblRetIni.Text = "Numero Nota:";
                lblRetResp.Text = "Resposta:";
                tbxRetTipo.Enabled = false;
                tbxRetFim.Enabled = false;
                tbxRetIni.Enabled = true;
                tbxRetSerie.Enabled = true;
                tbxRetChAcesso.Enabled = true;
                tbxRetInfo.Enabled = true;
                tbxRetResp.Enabled = false;
            }
        }
        private void btnExecutarRetorna_Click(object sender, EventArgs e)
        {
            if (cbxRetornos.SelectedIndex == 0) //rRetornarInformacao_NFCe ( strTipoIntervalo,  strInic,  strFim,  strSerie,  strChaveAcesso,  strInfoConsulta, Builder StrResposta)
            {
                string strTipo = tbxRetTipo.Text;
                string strIni = tbxRetIni.Text;
                string strFim = tbxRetFim.Text;
                string strSerie = tbxRetSerie.Text;
                string strChaveA = tbxRetChAcesso.Text;
                string strInfo = tbxRetInfo.Text;
                StringBuilder strResp = new StringBuilder(5000);
                iRet = Declaracoes.rRetornarInformacao_NFCe_Daruma(strTipo, strIni, strFim, strSerie, strChaveA, strInfo, strResp);
                strMsg = Declaracoes.TrataRetorno_NFCe(iRet);
                MessageBox.Show("Retorno do método: " + strMsg, "TrataRetorno_NFCe", MessageBoxButtons.OK, MessageBoxIcon.Information);
                tbxRetResp.Enabled = true;
                tbxRetResp.Text = strResp.ToString().Trim();
            }
            else if (cbxRetornos.SelectedIndex == 1) //rRetornarInformacaoArq_NFCe ( strTipoIntervalo,  strInic,  strFim,  strSerie,  strChaveAcesso,  strInfoConsulta,  strPathArqResposta)
            {
                string strTipo = tbxRetTipo.Text;
                string strIni = tbxRetIni.Text;
                string strFim = tbxRetFim.Text;
                string strSerie = tbxRetSerie.Text;
                string strChaveA = tbxRetChAcesso.Text;
                string strInfo = tbxRetInfo.Text;
                string strArqResp = tbxRetResp.Text;
                iRet = Declaracoes.rRetornarInformacaoArq_NFCe_Daruma(strTipo, strIni, strFim, strSerie, strChaveA, strInfo, strArqResp);
                strMsg = Declaracoes.TrataRetorno_NFCe(iRet);
                MessageBox.Show("Retorno do método: " + strMsg, "TrataRetorno_NFCe", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
            else if (cbxRetornos.SelectedIndex == 2) //rRetornarInformacaoContingencia_NFCe ( strChaveAcesso,  strNumNota,  strSerie,  strInfoConsulta, Builder strRetorno)
            {
                string strChaveA = tbxRetChAcesso.Text;
                string strNnf = tbxRetIni.Text;
                string strSerie = tbxRetSerie.Text;
                string strInfo = tbxRetInfo.Text;
                StringBuilder strResp = new StringBuilder(5000);
                iRet = Declaracoes.rRetornarInformacaoContingencia_NFCe_Daruma(strChaveA, strNnf, strSerie, strInfo, strResp);
                strMsg = Declaracoes.TrataRetorno_NFCe(iRet);
                MessageBox.Show("Retorno rRetornarInformacaoContingencia_NFCe: " + strMsg, "TrataRetorno_NFCe", MessageBoxButtons.OK, MessageBoxIcon.Information);
                tbxRetResp.Enabled = true;
                tbxRetResp.Text = strResp.ToString().Trim();
            }
        }

        private void btnImpTEF_Click(object sender, EventArgs e)
        {
            string strPathArq = tbxITEFPathArquivo.Text;
            int iNumVia = Convert.ToInt32(tbxITEFNumVias.Text);
            int iCortar = Convert.ToInt32(cbxITEFCorte.SelectedIndex);
            int iTravar = Convert.ToInt32(cbxITEFTravar.SelectedIndex);
            iRet = Declaracoes.iTEFImprimirResposta_NFCe_Daruma(strPathArq, iNumVia, iCortar, iTravar);
            strMsg = Declaracoes.TrataRetorno_NFCe(iRet);
            MessageBox.Show("Retorno iTEFImprimirResposta_NFCe: " + strMsg, "TrataRetorno_NFCe", MessageBoxButtons.OK, MessageBoxIcon.Information);

        }

        private void btnTesteVenda_Click(object sender, EventArgs e)
        {
            int iQtdItem = Convert.ToInt32(tbxTesteItens.Text);
            int iNumVenda = Convert.ToInt32(tbxTesteCupons.Text);
            int iItens = 0;
            int iCupom = 0;
            string desc = "";

            while (iCupom < iNumVenda)
            {
                iRet = Declaracoes.aCFAbrir_NFCe_Daruma("", "", "", "", "", "", "", "", "");
                if (iRet > 0 )
                {
                    for (iItens = 1; iItens <= iQtdItem; iItens++)
                    {
                        Declaracoes.aCFConfImposto_NFCe_Daruma("ICMS00", "0;00;3;;07,00;;;;");
                        desc = "Teste de Venda Item " + iItens.ToString();
                        Declaracoes.aCFVenderCompleto_NFCe_Daruma("07,00", "1,00", "0,10", "D$", "0,00", "1234", "18063210", "5102", "UND", desc, "CEST=1705700;cEAN=7896022204969;cEANTrib=7896022204969;");
                    }
                    Declaracoes.aCFTotalizar_NFCe_Daruma("D$", "0,00");
                    Declaracoes.aCFEfetuarPagamento_NFCe_Daruma("Dinheiro", "0,00");//para fazer pagamento do total
                    iRet = Declaracoes.tCFEncerrar_NFCe_Daruma("Teste de Venda Bufferizada NFC-e. IT FAST Automação Comercial - Exemplo C#.");
                }
                strMsg = Declaracoes.TrataRetorno_NFCe(iRet);
                if (iRet < 1) iCupom = iNumVenda;
                              
                iCupom++;
            }
            MessageBox.Show("Teste de venda retornou: " + strMsg, "TrataRetorno_NFCe", MessageBoxButtons.OK, MessageBoxIcon.Information);
            cbxMetodos.SelectedIndex = 0;
            btnExecutar.PerformClick();

        }

        private void button1_Click(object sender, EventArgs e)
        {
            iRet = Declaracoes.tCFCancelar_NFCe_Daruma("", "", "", "", "");
            strMsg = Declaracoes.TrataRetorno_NFCe(iRet);
            MessageBox.Show("Teste de venda Cancelar Venda Retornou: " + strMsg, "TrataRetorno_NFCe", MessageBoxButtons.OK, MessageBoxIcon.Information);
        }

    }
}
